VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ANSI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

Option Explicit
'/******************************************************************/
'/*                                                                */
'/*                      TurboCAD for Windows                      */
'/*                   Copyright (c) 1993 - 2000                    */
'/*             International Microcomputer Software, Inc.         */
'/*                            (IMSI)                              */
'/*                      All rights reserved.                      */
'/*                                                                */
'/******************************************************************/

'DBAPI constants
Const gkGraphic = 11
Const gkArc = 2
Const gkText = 6
Const gfCosmetic = 128&

'Useful math constants
Const Pi# = 3.14159265

'Real variant types!
Const typeEmpty = 0
Const typeInteger = 2
Const typeLong = 3
Const typeSingle = 4
Const typeDouble = 5
Const typeCurrency = 6
Const typeDate = 7
Const typeString = 8
Const typeObject = 9
Const typeBoolean = 11
Const typeVariant = 12
Const typeIntegerEnum = typeInteger + 100
Const typeLongEnum = typeLong + 100
Const typeStringEnum = typeString + 100

'Stock property pages
Const ppStockPen = 1
Const ppStockBrush = 2
Const ppStockText = 4
Const ppStockInsert = 8
Const ppStockViewport = 16
Const ppStockAuto = 32

'Property Ids
Const idText1 = 1
Const idText2 = 2
Const idText3 = 3
Const idText4 = 4
Const idText5 = 5
Const idText6 = 6

Const idImg0 = 7
Const idImg1 = 8

Const idHSym = 9

'Property enums

'Number of properties, pages, wizards
Const NUM_PROPERTIES = 9
Const NUM_PAGES = 1
Const NUM_WIZARDS = 0

Private Sub Class_Initialize()
    'Initialize class variables
End Sub

'Returns the user-visible description of this RegenMethod
Public Property Get Description() As String
    Description = "Surface Roughness"
End Property

'Returns the persistent class id for this RegenMethod's property section
Public Property Get ClassID() As String
    ClassID = "{FDB6F1CA-9631-11d1-A40A-0000B465872B}"
End Property

'Retrieve types and names
Public Function GetPropertyInfo(Names As Variant, Types As Variant, _
    IDs As Variant, Defaults As Variant) As Long
    ReDim Names(NUM_PROPERTIES), Types(NUM_PROPERTIES), _
        IDs(NUM_PROPERTIES), Defaults(NUM_PROPERTIES)
    
'    Names(0) = "Text11"
    Names(0) = "RougMinHeight"
    Types(0) = typeString
    IDs(0) = idText1
    Defaults(0) = "0.05"
    
'    Names(1) = "Text21"
    Names(1) = "RougMaxHeight"
    Types(1) = typeString
    IDs(1) = idText2
    Defaults(1) = ""
       
'    Names(2) = "Text31"
    Names(2) = "RougRemovalStock"
    Types(2) = typeString
    IDs(2) = idText3
    Defaults(2) = ""
    
'    Names(3) = "Text41"
    Names(3) = "RougCutOff"
    Types(3) = typeString
    IDs(3) = idText4
    Defaults(3) = ""
    
'    Names(4) = "Text51"
    Names(4) = "RougWidth"
    Types(4) = typeString
    IDs(4) = idText5
    Defaults(4) = ""
    
'    Names(5) = "Text61"
    Names(5) = "RougWavinessHeight"
    Types(5) = typeString
    IDs(5) = idText6
    Defaults(5) = ""
'// Surface Roughness type
'    Names(6) = "Image0"
    Names(6) = "RougType"
    Types(6) = typeInteger
    IDs(6) = idImg0
    Defaults(6) = 0
    
'    Names(7) = "Image1"
    Names(7) = "RougLaySymbol"
    Types(7) = typeInteger
    IDs(7) = idImg1
    Defaults(7) = 0

'Begin Scale
    
    Names(8) = "HSym"
    Types(8) = typeDouble
    IDs(8) = idHSym
    Defaults(8) = 0.25
        
'End Scale
    GetPropertyInfo = NUM_PROPERTIES
End Function

'Get the number of property pages supporting this RegenMethod
Public Function GetPageInfo(ByVal AGraphic As Object, StockPages As Long, _
    Names As Variant) As Long
    ReDim Names(NUM_PAGES)

    'Need the form
    Load frmRough
    Names(0) = frmRough.Caption
    Unload frmRough

'    StockPages = ppStockBrush + ppStockPen + ppStockAuto
    StockPages = ppStockPen + ppStockAuto
    GetPageInfo = NUM_PAGES
End Function

Public Function GetWizardInfo(Names As Variant) As Long
    ReDim Names(NUM_WIZARDS)
    GetWizardInfo = NUM_WIZARDS
End Function

'Enumerate the names and values of a specified property
Public Function GetEnumNames(ByVal PropID As Long, Names As Variant, Values As Variant) As Long
    GetEnumNames = 0
End Function

Public Function PageControls(ByVal ThisRegenMethod As Object, ByVal Graphic As Object, ByVal PageNumber As Long, ByVal SaveProperties As Boolean) As Boolean
        'Set up error function
        On Error GoTo Failed
Dim Str1$, Str2$, Str3$, Str4$, Str5$, Str6$
Dim FontHeight As Double
        If SaveProperties Then
            'OK button on property page was clicked
            'Form is still loaded
            With frmRough
               'Need On Error statement for the case where you have
                'RRect Turbo Shape and ahother "shape" selected
                On Error Resume Next
                Str1 = .Text1.Text
'                Graphic.Properties("Text11") = Str1
                Graphic.Properties("RougMinHeight") = Str1
                
                Str2 = .Text2.Text
'                Graphic.Properties("Text21") = Str2
                Graphic.Properties("RougMaxHeight") = Str2
                
                Str3 = .Text3.Text
'                Graphic.Properties("Text31") = Str3
                Graphic.Properties("RougRemovalStock") = Str3
                
                Str4 = .Text4.Text
'                Graphic.Properties("Text41") = Str4
                Graphic.Properties("RougCutOff") = Str4
                
                Str5 = .Text5.Text
'                Graphic.Properties("Text51") = Str5
                Graphic.Properties("RougWidth") = Str5
            
                Str6 = .Text6.Text
'                Graphic.Properties("Text61") = Str6
                Graphic.Properties("RougWavinessHeight") = Str6
            
'                Graphic.Properties("Image0") = Im0
                Graphic.Properties("RougType") = Im0
                
'                Graphic.Properties("Image1") = Im1
                Graphic.Properties("RougLaySymbol") = Im1
                
                FontHeight = CDbl(.LetterHeight.Text)
                Graphic.Properties("HSym") = FontHeight
            
            End With

        Else
            'Property page is about to be opened
            'Make sure the form is loaded
'//            Im0 = Graphic.Properties("Image0")
'//            Im1 = Graphic.Properties("Image1")
            Im0 = Graphic.Properties("RougType")
            Im1 = Graphic.Properties("RougLaySymbol")
            Load frmRough
            With frmRough
                'If more than one Rough-symbol is selected and they do not
                'have the same properties, don't set up this field
                On Error GoTo NoRType
                Str1 = Graphic.Properties("RougMinHeight")
                .Text1.Text = Str1
                Str10 = Str1
                
                Str2 = Graphic.Properties("RougMaxHeight")
                .Text2.Text = Str2
                Str20 = Str2
                
                Str3 = Graphic.Properties("RougRemovalStock")
                .Text3.Text = Str3
                 Str30 = Str3

                Str4 = Graphic.Properties("RougCutOff")
                .Text4.Text = Str4
                Str40 = Str4
                
                Str5 = Graphic.Properties("RougWidth")
                .Text5.Text = Str5
                Str50 = Str5
                
                 Str6 = Graphic.Properties("RougWavinessHeight")
                .Text6.Text = Str6
                Str60 = Str6
               
'                Im0 = Graphic.Properties("Image0")
'                Im1 = Graphic.Properties("Image1")
                FontHeight = Graphic.Properties("HSym")
                .LetterHeight.Text = CStr(FontHeight)
                LetterHeight0 = CStr(FontHeight)
NoRType:
            End With
        
        End If

        PageControls = True
        Exit Function

Failed:
        'For debugging purposes, report that an error occurred
        If Err.Number <> 0 Then
            MsgBox "Error in PageControls: " & Err.Description
        End If

        'Return false if an error occurred
        PageControls = False
End Function

Public Function PageDone(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant)
        'Done with form
        Unload frmRough
End Function

Public Function PropertyPages(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant) As Boolean
    With frmRough
        .Show vbModal
        PropertyPages = Not .DialogCanceled
    End With
End Function

Public Function Wizard(ByVal ThisRegenMethod As Object, Optional WizardNumber As Variant) As Boolean
    Wizard = False
End Function

'Called when vertex has been moved, or other geometry change
Public Function OnGeometryChanged(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant)
    'Do nothing
    'Regen Graphic
End Function

'Called when vertex is moved, or other geometry change
Public Function OnGeometryChanging(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant) As Boolean
    'OK to continue with change
    OnGeometryChanging = True
End Function

Public Function OnNewGraphic(ByVal grfThis As Object, ByVal boolCopy As Boolean) As Boolean
    If boolCopy Then
        'Vertices are already added for us...
        OnNewGraphic = True
        Exit Function
    End If
    Im0 = 0
    Im1 = 0
    On Error Resume Next
    grfThis.Properties("Thickness") = 0
    Err.Clear
    On Error GoTo Failed
    'New Graphic being created
    'X, Y, Z, PenDown, Selectable, Snappable, Editable, Linkable
    'First Vertex is "lower left" corner
    grfThis.Vertices.Add 1#, 0#, 0#, False, True, True, True, True
    'Second Vertex is additional
    grfThis.Vertices.Add 1.5, 0#, 0#, False, True, True, True, True
    grfThis.Properties("LimitVertices") = 2
    OnNewGraphic = True
    Exit Function

Failed:
    'Return false on failure
    OnNewGraphic = False
End Function

'Function called whenever a copy of a graphic is being made
Public Function OnCopyGraphic(ByVal grfCopy As Object, ByVal grfSource As Object) As Boolean
    'Return false on failure
    OnCopyGraphic = True
End Function

'Notification function called after graphic property is saved
Public Function OnPropertyChanged(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant)
    'Do nothing
End Function

'Notification function called when graphic property is saved
Public Function OnPropertyChanging(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant) As Boolean
    'OK to proceed
    OnPropertyChanging = True
End Function

'Notification function called when graphic property is retrieved
Public Function OnPropertyGet(ByVal Graphic As Object, ByVal PropID As Long)
    'Do nothing
End Function

'Called when we need to update our object
Public Function Regen(ByVal grfThis1 As Object)
        'Setup error handler
        
        On Error GoTo Failed
Dim grfThis As Graphic
        Set grfThis = grfThis1
        grfThis.Properties("PenStyle") = "CONTINUOUS"
        'Set up lock (prevent recursion)
        Dim LockCount&
        LockCount& = grfThis.RegenLock
        Dim Col As Long
        Col = grfThis.Properties("PenColor")
        'Setup error handler (make sure lock is removed)
        On Error Resume Next
        grfThis.Properties("Thickness") = 0
        Err.Clear

        On Error GoTo FailedLock
        If LockCount& = 0 Then
            'Delete any previous cosmetic children
            grfThis.Graphics.Clear gfCosmetic
        
            
Dim W#, H#, R#, Hs#
Dim Str1$, Str2$, Str3$, Str4$, Str5$, Str6$
Dim Gr As Graphic
            
            Str1 = grfThis.Properties("RougMinHeight")
            Str2 = grfThis.Properties("RougMaxHeight")
            Str3 = grfThis.Properties("RougRemovalStock")
            Str4 = grfThis.Properties("RougCutOff")
            Str5 = grfThis.Properties("RougWidth")
            Str6 = grfThis.Properties("RougWavinessHeight")
            Im0 = grfThis.Properties("RougType")
            Im1 = grfThis.Properties("RougLaySymbol")
            H = grfThis.Properties("HSym")
            Hs = H

            'Add child Graphics
Dim Salp#, Calp#, L#
Dim X00#, Y00#, X01#, Y01#
            With grfThis.Vertices
                X00 = .Item(0).X
                Y00 = .Item(0).Y
                X01 = .Item(1).X
                Y01 = .Item(1).Y
                L = Sqr((X01 - X00) * (X01 - X00) + (Y01 - Y00) * (Y01 - Y00))
                Salp = (Y01 - Y00) / L
                Calp = (X01 - X00) / L
            End With
Dim alp#
            If Calp = 0# Then
               If Salp > 0 Then
                   alp = Pi / 2#
                   GoTo LL
               End If
               If Salp < 0 Then
                   alp = 3# * Pi / 2#
                   GoTo LL
               End If
            End If
            
            If Salp >= 0# And Calp > 0# Then
               alp = Atn(Abs(Salp / Calp))
            End If
            If Salp >= 0# And Calp < 0# Then
               alp = Pi - Atn(Abs(Salp / Calp))
            End If
            If Salp <= 0# And Calp < 0# Then
               alp = Pi + Atn(Abs(Salp / Calp))
            End If
            If Salp <= 0# And Calp > 0# Then
               alp = 2# * Pi - Atn(Abs(Salp / Calp))
            End If
LL:
            If alp > 6.28 Then alp = 0#
            If alp < 0.01 Then alp = 0#
       
'MsgBox ("alp=" & CStr(alp))
            Salp = Sin(alp)
            Calp = Cos(alp)
Dim X(30) As Double
Dim Y(30) As Double
Dim i As Long

                                   
Dim Xb#, Yb#


Dim xSymMin#, ySymMin#, xSymMax#, ySymMax#, xSymMid#, ySymMid#
' -------------------------------------------------------------
'------------------------------------------------------
' Symbol  Symbol  Symbol  Symbol  Symbol  Symbol

            xSymMin = -H * Tan(Pi / 6#)
            ySymMin = 0
            xSymMax = 2# * H * Tan(Pi / 6#)
            ySymMax = 2# * H
            xSymMid = H * Tan(Pi / 6#)
            ySymMid = H
    
            If Im0 = 0 Then
                X(1) = -H * Tan(Pi / 6#)
                Y(1) = H
                X(2) = 0#
                Y(2) = 0#
                X(3) = 2# * H * Tan(Pi / 6#)
                Y(3) = 2# * H
                Set Gr = grfThis.Graphics.Add(11)
                Gr.Properties("PenStyle") = "CONTINUOUS"
                Gr.Cosmetic = True
                With Gr.Vertices
                    .Add X(1), Y(1), 0
                    .Add X(2), Y(2), 0
                    .Add X(3), Y(3), 0
                End With
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
        
            If Im0 = 1 Then
                X(1) = -H * Tan(Pi / 6#)
                Y(1) = H
                X(2) = 0#
                Y(2) = 0#
                X(3) = 2# * H * Tan(Pi / 6#)
                Y(3) = 2# * H
                X(4) = H * Tan(Pi / 6#)
                Y(4) = H
                Set Gr = grfThis.Graphics.Add(11)
                Gr.Properties("PenStyle") = "CONTINUOUS"
                Gr.Cosmetic = True
                With Gr.Vertices
                    .Add X(4), Y(4), 0
                    .Add X(1), Y(1), 0
                    .Add X(2), Y(2), 0
                    .Add X(3), Y(3), 0
                End With
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
            If Im0 = 2 Then
                X(1) = -H * Tan(Pi / 6#)
                Y(1) = H
                X(2) = 0#
                Y(2) = 0#
                X(3) = 2# * H * Tan(Pi / 6#)
                Y(3) = 2# * H
                X(4) = 0#
                Y(4) = 2# / 3# * H
                X(5) = 1# / 3# * H
                Y(5) = 2# / 3# * H
             
                Set Gr = grfThis.Graphics.Add(11)
                Gr.Cosmetic = True
                Gr.Properties("PenStyle") = "CONTINUOUS"
                With Gr.Vertices
                    .Add X(1), Y(1), 0
                    .Add X(2), Y(2), 0
                    .Add X(3), Y(3), 0
                End With
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
                Set Gr = grfThis.Graphics.AddCircleCenterAndPoint(X(4), Y(4), 0, X(5), Y(5), 0)
                        Gr.Cosmetic = True
                        Gr.Properties("PenStyle") = "CONTINUOUS"
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
    
        
Dim BBox As BoundingBox
'--------------------------------------------------------------
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' Text Filds Text2=Str2  Text3=Str3  Text4=Str4
Dim xMax#, yMax#, xMin#, yMin#
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ' text1
            If Len(Str1) > 0 Then
                If alp <= 1.001 * Pi / 2# Or alp >= 0.999 * 3# * Pi / 2# Then
                    Set Gr = grfThis.Graphics.AddText(Str1, 0, 0, 0, Hs)
                                Gr.Cosmetic = True
               Else
                    Set Gr = grfThis.Graphics.AddText(Str1, 0, 0, 0, Hs, Pi)
                                Gr.Cosmetic = True
               End If
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                Gr.MoveRelative xSymMid - xMax, ySymMid - yMin, 0
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ' text2

            If Len(Str2) > 0 Then
                If alp <= 1.001 * Pi / 2# Or alp >= 0.999 * 3# * Pi / 2# Then
                    Set Gr = grfThis.Graphics.AddText(Str2, 0, 0, 0, Hs)
                               Gr.Cosmetic = True
                Else
                    Set Gr = grfThis.Graphics.AddText(Str2, 0, 0, 0, Hs, Pi)
                                Gr.Cosmetic = True
                End If
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                Gr.MoveRelative xSymMid - xMax, ySymMax - yMin, 0
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
           End If
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        'text 3
            If Len(Str3) > 0 Then
                If alp <= 1.001 * Pi / 2# Or alp >= 0.999 * 3# * Pi / 2# Then
                    Set Gr = grfThis.Graphics.AddText(Str3, 0, 0, 0, Hs, 0)
                                Gr.Cosmetic = True
                Else
                    Set Gr = grfThis.Graphics.AddText(Str3, 0, 0, 0, Hs, Pi)
                                Gr.Cosmetic = True
               End If
                
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                Gr.MoveRelative xSymMin - xMax, ySymMin - yMin, 0
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
'+++++++++++++++++++++++++++++++++++++++++++++++++++++
    ' Text4
Dim dx4#
             dx4 = 0
             If Len(Str4) > 0 Then
                 If alp <= 1.001 * Pi / 2# Or alp >= 0.999 * 3# * Pi / 2# Then
                     Set Gr = grfThis.Graphics.AddText(Str4, Xb, Yb, 0, Hs, 0)
                                 Gr.Cosmetic = True
                 Else
                     Set Gr = grfThis.Graphics.AddText(Str4, Xb, Yb, 0, Hs, Pi)
                                 Gr.Cosmetic = True
                 End If
                 xMax = Gr.CalcBoundingBox.Max.X
                 yMax = Gr.CalcBoundingBox.Max.Y
                 xMin = Gr.CalcBoundingBox.Min.X
                 yMin = Gr.CalcBoundingBox.Min.Y
                 Gr.MoveRelative xSymMax - xMin, ySymMid - yMin, 0
                 dx4 = Abs(xMax - xMin)
                 Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                 Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Dim dxb#
            dxb = 0
            If Im1 = 1 Then
                    X(1) = -0.35 * H
                    Y(1) = -0.15 * H
                    X(2) = 0.35 * H
                    Y(2) = Y(1)
                    X(3) = X(1)
                    Y(3) = 0.15 * H
                    X(4) = X(2)
                    Y(4) = Y(3)
                    Set Gr = grfThis.Graphics.Add(11)
                        Gr.Cosmetic = True
                        Gr.Properties("PenStyle") = "CONTINUOUS"
                    With Gr.Vertices
                        .Add X(1), Y(1), 0
                        .Add X(2), Y(2), 0
                        .Add X(3), Y(3), 0, False
                        .Add X(4), Y(4), 0
                    End With
                
                If alp > 1.001 * Pi / 2# And alp < 0.999 * 3# * Pi / 2# Then
                    Gr.RotateAxis Pi, 0, 0, 1
                End If
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                Gr.MoveRelative xSymMid - xMin, ySymMin - yMin, 0
                If alp > 1.001 * Pi / 2# And alp < 0.999 * 3# * Pi / 2# Then
                    Gr.MoveRelative 0, Hs / 2, 0
                Else
                    Gr.MoveRelative 0, Hs / 4, 0
                End If
'                Gr.MoveRelative 0, Hs / 4, 0
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
                dxb = Abs(xMax - xMin)
            End If


            If Im1 = 2 Then
                X(1) = -0.4 * H
                Y(1) = 0.1 * H
                X(2) = 0.4 * H
                Y(2) = Y(1)
                X(3) = (X(1) + X(2)) / 2
                Y(3) = Y(1)
                X(4) = X(3)
                Y(4) = Y(1) + 0.6 * H
                Set Gr = grfThis.Graphics.Add(11)
                        Gr.Cosmetic = True
                        Gr.Properties("PenStyle") = "CONTINUOUS"
                With Gr.Vertices
                    .Add X(1), Y(1), 0
                    .Add X(2), Y(2), 0
                    .Add X(3), Y(3), 0, False
                    .Add X(4), Y(4), 0
                End With
                
                If alp > 1.001 * Pi / 2# And alp < 0.999 * 3# * Pi / 2# Then
                    Gr.RotateAxis Pi, 0, 0, 1
                End If
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                Gr.MoveRelative xSymMid - xMin, ySymMin - yMin, 0
                If alp > 1.001 * Pi / 2# And alp < 0.999 * 3# * Pi / 2# Then
                    Gr.MoveRelative 0, Hs / 4, 0
                Else
                    Gr.MoveRelative 0, Hs / 8, 0
                End If
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
                dxb = Abs(xMax - xMin)
            End If

Dim Str As String
            If Im1 > 2 Then
                If Im1 = 3 Then Str = "X"
                If Im1 = 4 Then Str = "C"
                If Im1 = 5 Then Str = "M"
                If Im1 = 6 Then Str = "R"
                If Im1 = 7 Then Str = "P"
                
                If alp <= 1.001 * Pi / 2# Or alp >= 0.999 * 3# * Pi / 2# Then
                    Set Gr = grfThis.Graphics.AddText(Str, 0, 0, 0, Hs)
                                Gr.Cosmetic = True
                Else
                    Set Gr = grfThis.Graphics.AddText(Str, 0, 0, 0, Hs, Pi)
                                Gr.Cosmetic = True
               End If
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                Gr.MoveRelative xSymMid - xMin, ySymMin - yMin, 0
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
                dxb = Abs(xMax - xMin)
            End If


'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Dim dX5#
            dX5 = 0#
            If Len(Str5) > 0 Then
                If alp <= 1.001 * Pi / 2# Or alp >= 0.999 * 3# * Pi / 2# Then
                    Set Gr = grfThis.Graphics.AddText(Str5, 0, 0, 0, Hs, 0)
                                Gr.Cosmetic = True
                Else
                    Set Gr = grfThis.Graphics.AddText(Str5, 0, 0, 0, Hs, Pi)
                                Gr.Cosmetic = True
                End If
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                dX5 = Abs(xMax - xMin)
                Gr.MoveRelative xSymMid + 1.2 * dxb - xMin, ySymMin - yMin, 0
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ' text 6

Dim dx6#
            dx6 = 0
            If Len(Str6) > 0 Then
                If alp <= 1.001 * Pi / 2# Or alp >= 0.999 * 3# * Pi / 2# Then
                    Set Gr = grfThis.Graphics.AddText(Str6, 0, 0, 0, Hs, 0)
                                Gr.Cosmetic = True
                Else
                    Set Gr = grfThis.Graphics.AddText(Str6, 0, 0, 0, Hs, Pi)
                                Gr.Cosmetic = True
                End If
                xMax = Gr.CalcBoundingBox.Max.X
                yMax = Gr.CalcBoundingBox.Max.Y
                xMin = Gr.CalcBoundingBox.Min.X
                yMin = Gr.CalcBoundingBox.Min.Y
                Gr.MoveRelative xSymMax - xMin, ySymMax - yMin, 0
                dx6 = Abs(xMax - xMin)
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ' add line
Dim dxMax#
            dxMax = 0
            If dx4 > dxMax Then dxMax = dx4
            If dxb + dX5 > dxMax Then dxMax = dxb + dX5
            If dx6 > dxMax Then dxMax = dx6
        
            If Abs(xMax) > 0.0001 Then
                X(1) = xSymMax
                Y(1) = ySymMax
                X(2) = X(1) + dxMax
                Set Gr = grfThis.Graphics.Add(11)
                    Gr.Cosmetic = True
                With Gr.Vertices
                    .Add X(1), Y(1), 0
                    .Add X(2), Y(1), 0
                End With
                Gr.RotateAxis alp, 0, 0, 1, 0, 0, 0
                Gr.MoveRelative X00, Y00, 0
                Gr.Properties("PenColor") = Col 'grfThis.Properties("PenColor")
            End If
            'Add visible child Graphics
Dim CountCosm As Long, iCosm As Long, nV As Long, iV As Long, xi#, yi#, xir#, yir#
        Dim GrChild As Graphic
            CountCosm = grfThis.Graphics.Count
            For iCosm = 0 To CountCosm - 1
                Set GrChild = grfThis.Graphics.Item(iCosm)
'                If iCosm <> 0 Then
                    On Error Resume Next
                    GrChild.Properties("PenStyle") = "CONTINUOUS"
                    GrChild.Properties("Thickness") = 0
                    GrChild.Update
'                End If
               Set GrChild = Nothing
            Next iCosm
            Err.Clear
        
        End If
LLL:
    
        X01 = X00 + (xSymMax + dxMax) * Calp
        Y01 = Y00 + (xSymMax + dxMax) * Salp
        grfThis.Vertices(1).X = X01
        grfThis.Vertices(1).Y = Y01

        
        grfThis.RegenUnlock

       
        Exit Function

FailedLock:
        'Remove lock
        grfThis.RegenUnlock

Failed:

        If Err.Number <> 0 Then
            MsgBox "Regen error: " & Err.Description
        End If
End Function

Public Function Draw(ByVal grfThis As Object, ByVal view As Object, Optional mat As Variant) As Boolean
    'Return True if we did the redraw (no further processing necessary, no children will be drawn).
    'Since this is just a test, we return False to let TurboCAD do the drawing operation.
    Draw = False
End Function


