VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DimTie"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'/******************************************************************/
'/*                                                                */
'/*                      TurboCAD for Windows                      */
'/*                   Copyright (c) 1993 - 2001                    */
'/*             International Microcomputer Software, Inc.         */
'/*                            (IMSI)                              */
'/*                      All rights reserved.                      */
'/*                                                                */
'/******************************************************************/

Option Explicit
Implements ITurboCADSmartTieServer

'Private Declare Function TCWDrawingActive Lib "TCAPI90.dll" () As Long
'Private Declare Function TCWGraphicAt Lib "TCAPI90.dll" (ByVal d As Long, ByVal Index As Long) As Long
'Private Declare Function TCWVertexAt Lib "TCAPI90.dll" (ByVal g As Long, ByVal Index As Long) As Long

'Private Declare Sub prVertexSetSomeFlags Lib "DBAPI90.dll" (ByVal hVer As Long, ByVal FlagOn As Long, ByVal FlagOff As Long)

'Private Declare Function GraphicGetMatrix Lib "DBAPI90.dll" (ByVal hGr As Long) As Long
'Private Declare Function GraphicSetMatrix Lib "DBAPI90.dll" (ByVal hGr As Long, ByVal hMat As Long) As Boolean
'Private Declare Function MatrixEqual Lib "DBAPI90.dll" (ByVal hM1 As Long, ByVal hM2 As Long) As Boolean

'Useful math constants
Const Pi# = 3.14159265
Const Eps = 0.000001


Public Type VertexTieData
    R As Double
    xc As Double
    yc As Double
    x1 As Double
    y1 As Double
    x2 As Double
    y2 As Double
    iVer As Long
    fiRel As Double
End Type

Private idVTie As String

Private TSets As TieSets
Private TSet  As TieSet
Private Tie   As Tie
Private ActDr   As Drawing
Private tieData As VertexTieData
    
Private VersSbj As Vertices
Private VersSbd As Vertices

Private Grs   As Graphics
Private GrSbj As Graphic
Private GrSbd As Graphic

Private hDr As Long
Private hGrArc As Long
Private hGrDim As Long
Private hMatArc As Long
Private hMatDim As Long


Private Function Clear()
    
    Set VersSbj = Nothing
    Set VersSbd = Nothing
    
    Set GrSbj = Nothing
    Set GrSbd = Nothing
    Set Grs = Nothing
    Set Tie = Nothing
    Set TSet = Nothing
    Set TSets = Nothing
    Set ActDr = Nothing

End Function


Private Function ITurboCADSmartTieServer_AddTie(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long, ByVal lType As Long) As Boolean
'MsgBox ("AddTie")
Dim varData As Variant
    Set ActDr = pIDispDwg
    Set GrSbj = Nothing
    Set GrSbd = Nothing
    Set GrSbj = ActDr.Graphics.GraphicFromID(idSbj)
    Set GrSbd = ActDr.Graphics.GraphicFromID(idSbd)
Dim GrDim As Graphic
Dim GrCon As Graphic
Dim GrConType$
    
    If GrSbj.Type = "TCW25DimRad" Or GrSbj.Type = "TCW25DimDia" Then
        Set GrDim = GrSbj
        Set GrCon = GrSbd
    Else
        Set GrDim = GrSbd
        Set GrCon = GrSbj
    End If
    GrConType = GrCon.Type
Dim GrDimType$
    GrDimType = GrDim.Type
    
Dim x0Dim#, y0Dim#, x1Dim#, y1Dim#, x2Dim#, y2Dim#
    With GrDim.Vertices
        x0Dim = .Item(0).X
        y0Dim = .Item(0).Y
        x1Dim = .Item(1).X
        y1Dim = .Item(1).Y
        .Item(1).Editable = False
        x2Dim = .Item(2).X
        y2Dim = .Item(2).Y
    End With
Dim R#, xc#, yc#, iVer As Long
Dim x1#, y1#, fiRel#
    fiRel = 0
    If GrConType = "ARC" Or GrConType = "CIRCLE" Then
        With GrCon.Vertices
            xc = .Item(0).X
            yc = .Item(0).Y
            x1 = .Item(1).X
            y1 = .Item(1).Y
        End With
        iVer = 0
    End If
        
    If GrConType = "TCW50Polyline" Then
Dim nV As Long, i As Long, xi#, yi#
        With GrCon.Vertices
            nV = .Count
            For i = 0 To nV - 1
                If .Item(i).Bulge = True Then
                    xi = .Item(i).X
                    yi = .Item(i).Y
                    If Abs(xi - x0Dim) < Eps And Abs(yi - y0Dim) < Eps Then
                        xc = xi
                        yc = yi
                        x1 = .Item(i + 1).X
                        y1 = .Item(i + 1).Y
                        iVer = i
                        Exit For
                    End If
                End If
            Next i
        End With
    End If
    
    R = Sqr((x1 - xc) * (x1 - xc) + (y1 - yc) * (y1 - yc))
    
    Set TSets = ActDr.TieSets
    Set TSet = TSets.TieSet(idSbj, idSbd)
        tieData.R = R
        tieData.xc = xc
        tieData.yc = yc
        tieData.x1 = x1Dim
        tieData.y1 = y1Dim
        tieData.x2 = x2Dim
        tieData.y2 = y2Dim
        tieData.iVer = iVer
        tieData.fiRel = fiRel
        varData = tieData
        TSet.AddTie idVTie, 1, varData
    
    Set TSet = TSets.TieSet(idSbd, idSbj)
        tieData.R = R
        tieData.xc = xc
        tieData.yc = yc
        tieData.x1 = x1Dim
        tieData.y1 = y1Dim
        tieData.x2 = x2Dim
        tieData.y2 = y2Dim
        tieData.iVer = iVer
        tieData.fiRel = fiRel
        varData = tieData
        TSet.AddTie idVTie, 1, varData
        
        Set GrDim = Nothing
        Set GrCon = Nothing
    ITurboCADSmartTieServer_AddTie = True
    Clear

End Function

Private Function ITurboCADSmartTieServer_CopyTie(ByVal pIDispDwg As Object, ByVal idSbjSrc As Long, ByVal idSbdSrc As Long, ByVal idSbjTrg As Long, ByVal idSbdTrg As Long) As Boolean
    
    Set ActDr = pIDispDwg
    Set Grs = ActDr.Graphics
    Set GrSbj = Grs.GraphicFromID(idSbjTrg)
    Set GrSbd = Grs.GraphicFromID(idSbdTrg)
    
    Set TSets = ActDr.TieSets
    Set TSet = TSets.TieSet(idSbjSrc, idSbdSrc)
    Set Tie = TSet(0)
    tieData = Tie.Data
    
    Set Tie = TSet(0)
    Tie.Data = tieData
    
    Clear

    ITurboCADSmartTieServer_CopyTie = True
End Function

Private Function ITurboCADSmartTieServer_DeleteTie(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long, ByVal pIDsipGr As Object) As Boolean
    ITurboCADSmartTieServer_DeleteTie = True
End Function

Private Property Get ITurboCADSmartTieServer_Description() As String
    ITurboCADSmartTieServer_Description = "RadDimevsion_Tie"
End Property

Private Function ITurboCADSmartTieServer_GetIDs(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long) As Variant
' It is not need to do something here because this method doesn't use Graphic's DataBase ID
End Function

Private Function ITurboCADSmartTieServer_GetTypesInfo(Names As Variant, Types As Variant) As Long
    ITurboCADSmartTieServer_GetTypesInfo = 0
End Function

Private Function ITurboCADSmartTieServer_Initialize(ByVal ThisTieMethod As Object) As Boolean
    Dim gxTMethod As TieMethod
    Set gxTMethod = ThisTieMethod
    idVTie = gxTMethod.Name
    ITurboCADSmartTieServer_Initialize = True
End Function


Private Sub ITurboCADSmartTieServer_SetIDs(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long, pvarIDs As Variant)
' It is not need to do something here because this method doesn't use Graphic's DataBase ID
End Sub

Private Function ITurboCADSmartTieServer_TieCanNODEED(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long) As Boolean
    ITurboCADSmartTieServer_TieCanNODEED = True
End Function

Private Function ITurboCADSmartTieServer_UpdateTie(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long) As Integer
    
    Set ActDr = pIDispDwg
    
    Set TSets = ActDr.TieSets
    Set TSet = TSets.TieSet(idSbj, idSbd)

    UpdateTie TSet, TSets, idSbj, idSbd


    ITurboCADSmartTieServer_UpdateTie = 0
    Clear

End Function


Private Function Angle(sinb As Double, cosb As Double) As Double

        If Abs(cosb) < 0.0001 Then
            If sinb > 0 Then
                Angle = Pi / 2
            Else
                Angle = 3 * Pi / 2
            End If
        Else
            If sinb >= 0 And cosb > 0 Then Angle = Atn(sinb / cosb)
            If sinb >= 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb > 0 Then Angle = 2 * Pi + Atn(sinb / cosb)
        End If
End Function

' Define the direction of Arc rotation
' return ArcRotation = 1 if CounterClockwise
' return ArcRotation = -1 if Clockwise

Private Function ArcRotation(xB As Double, yB As Double, xDir As Double, yDir As Double, xc As Double, yc As Double, R As Double) As Integer
Dim sina#, cosa# ', Alp0#, Alp1#
    sina = (yB - yc) / R
    cosa = (xB - xc) / R
Dim xLoc#, yLoc#
    xLoc = (yDir - yc) * sina + (xDir - xc) * cosa
    yLoc = (yDir - yc) * cosa - (xDir - xc) * sina
    If yLoc > 0 Then
        ArcRotation = -1
    Else
        ArcRotation = 1
    End If
End Function


'###################################################################
'###################################################################
'###################################################################

Private Function UpdateTie(ByRef TSet As TieSet, ByRef TSets As TieSets, ByVal idSbj As Long, ByVal idSbd As Long)
    Dim varData As Variant
    Set ActDr = TSets.Drawing
    Set GrSbj = Nothing
    Set GrSbd = Nothing
    Set GrSbj = ActDr.Graphics.GraphicFromID(idSbj)
    Set GrSbd = ActDr.Graphics.GraphicFromID(idSbd)
    
    Set Tie = TSet(0)
    varData = Tie.Data
    tieData = varData(0)
Dim ROld#, xcOld#, ycOld#, x1Old#, y1Old#, iVer As Long, fiRel#
    ROld = tieData.R
    xcOld = tieData.xc
    ycOld = tieData.yc
    x1Old = tieData.x1
    y1Old = tieData.y1
    iVer = tieData.iVer
    fiRel = tieData.fiRel
    
Dim GrDim As Graphic
Dim GrCon As Graphic
Dim GrConType$
Dim EditedGr$

    If GrSbj.Type = "TCW25DimRad" Or GrSbj.Type = "TCW25DimDia" Then
        EditedGr = "Dim"
        Set GrDim = GrSbj
        Set GrCon = GrSbd
    Else
        EditedGr = "Base"
        Set GrDim = GrSbd
        Set GrCon = GrSbj
    End If
    
    GrConType = GrCon.Type
Dim GrDimType$
    GrDimType = GrDim.Type
Dim xcArc#, ycArc#, x1Arc#, y1Arc#, RArc#
Dim dx#, dy#
Dim x0Dim#, y0Dim#, x1Dim#, y1Dim#, x2Dim#, y2Dim#


' ##########################################################################
' ##########################################################################
' ##########################################################################
' ##########################################################################
    If EditedGr = "Base" Then
        With GrDim.Vertices
            x0Dim = .Item(0).X
            y0Dim = .Item(0).Y
            x1Dim = .Item(1).X
            y1Dim = .Item(1).Y
            x2Dim = .Item(2).X
            y2Dim = .Item(2).Y
        End With
Dim R12Dim#
        R12Dim = Sqr((x2Dim - x0Dim) * (x2Dim - x0Dim) + (y2Dim - y0Dim) * (y2Dim - y0Dim))
        If GrConType = "ARC" Or GrConType = "CIRCLE" Then
        
            With GrCon.Vertices
                xcArc = .Item(0).X
                ycArc = .Item(0).Y
                x1Arc = .Item(1).X
                y1Arc = .Item(1).Y
            End With
        Else
            With GrCon.Vertices
                xcArc = .Item(iVer).X
                ycArc = .Item(iVer).Y
                x1Arc = .Item(iVer + 1).X
                y1Arc = .Item(iVer + 1).Y
            End With
        End If
        RArc = Sqr((x1Arc - xcArc) * (x1Arc - xcArc) + (y1Arc - ycArc) * (y1Arc - ycArc))
        x0Dim = xcArc
        y0Dim = ycArc
        x1Dim = x0Dim + (x1Old - xcOld) * RArc / ROld
        y1Dim = y0Dim + (y1Old - ycOld) * RArc / ROld
        x2Dim = x1Dim + (x1Dim - x0Dim) / RArc * (R12Dim - ROld)
        y2Dim = y1Dim + (y1Dim - y0Dim) / RArc * (R12Dim - ROld)
        
        With GrDim.Vertices
            .Item(0).X = x0Dim
            .Item(0).Y = y0Dim
            .Item(2).X = x2Dim
            .Item(2).Y = y2Dim
            .Item(1).X = x1Dim
            .Item(1).Y = y1Dim
        End With
        GrDim.Update
        GrDim.Draw
        GrDim.Vertices(1).Editable = False
        ' Write New Data into TSet Structures
        Set TSets = ActDr.TieSets
        Set TSet = TSets.TieSet(idSbj, idSbd)
            tieData.R = RArc
            tieData.xc = x0Dim
            tieData.yc = y0Dim
            tieData.x1 = x1Dim
            tieData.y1 = y1Dim
            tieData.x2 = x2Dim
            tieData.y2 = y2Dim
            tieData.iVer = iVer
            tieData.fiRel = fiRel
            varData = tieData
            TSet.AddTie idVTie, 1, varData
        
        Set TSet = TSets.TieSet(idSbd, idSbj)
            tieData.R = RArc
            tieData.xc = x0Dim
            tieData.yc = y0Dim
            tieData.x1 = x1Dim
            tieData.y1 = y1Dim
            tieData.x2 = x2Dim
            tieData.y2 = y2Dim
            tieData.iVer = iVer
            tieData.fiRel = fiRel
            varData = tieData
            TSet.AddTie idVTie, 1, varData
    End If
' ##########################################################################
' ##########################################################################
' ##########################################################################
' ##########################################################################
    
    If EditedGr = "Dim" Then
        With GrDim.Vertices
            x0Dim = .Item(0).X
            y0Dim = .Item(0).Y
            x1Dim = .Item(1).X
            y1Dim = .Item(1).Y
            x2Dim = .Item(2).X
            y2Dim = .Item(2).Y
        End With
        If GrConType = "ARC" Or GrConType = "CIRCLE" Then
            With GrCon.Vertices
                xcArc = .Item(0).X
                ycArc = .Item(0).Y
                x1Arc = .Item(1).X
                y1Arc = .Item(1).Y
            End With
        Else
            With GrCon.Vertices
                xcArc = .Item(iVer).X
                ycArc = .Item(iVer).Y
                x1Arc = .Item(iVer + 1).X
                y1Arc = .Item(iVer + 1).Y
            End With
        End If
        RArc = Sqr((x1Arc - xcArc) * (x1Arc - xcArc) + (y1Arc - ycArc) * (y1Arc - ycArc))

        With GrDim.Vertices
            x0Dim = .Item(0).X
            y0Dim = .Item(0).Y
            x1Dim = .Item(1).X
            y1Dim = .Item(1).Y
            x2Dim = .Item(2).X
            y2Dim = .Item(2).Y
            .Item(0).X = xcArc
            .Item(0).Y = ycArc
        End With
        
Dim R01Dim#, R02Dim#
        R01Dim = Sqr((x1Dim - x0Dim) * (x1Dim - x0Dim) + (y1Dim - y0Dim) * (y1Dim - y0Dim))
        R02Dim = Sqr((x2Dim - xcArc) * (x2Dim - xcArc) + (y2Dim - ycArc) * (y2Dim - ycArc))

Dim StrInfo$, Str#
Dim StrLen%
Dim RInfo#
        If GrConType = "ARC" Or GrConType = "CIRCLE" Then
            StrInfo = GrDim.Properties("Info")
            StrLen = VBA.Len(StrInfo)
            Str = VBA.Right(StrInfo, StrLen - 1)
            RInfo = CDbl(Str)
            If Abs(RInfo - RArc) > GrDim.Properties("$DIMRND") Then
Dim x2Arc#, y2Arc#, x3Arc#, y3Arc#
                With GrCon.Vertices
                    xcArc = .Item(0).X
                    ycArc = .Item(0).Y
                    x1Arc = .Item(1).X
                    y1Arc = .Item(1).Y
                    x2Arc = .Item(2).X
                    y2Arc = .Item(2).Y
                    x3Arc = .Item(3).X
                    y3Arc = .Item(3).Y
                    GrCon.Visible = False
                    GrCon.Draw
                    
                    .Item(1).X = xcArc + (x1Arc - xcArc) * RInfo / RArc
                    .Item(1).Y = ycArc + (y1Arc - ycArc) * RInfo / RArc
                    .Item(2).X = xcArc + (x2Arc - xcArc) * RInfo / RArc
                    .Item(2).Y = ycArc + (y2Arc - ycArc) * RInfo / RArc
                    .Item(3).X = xcArc + (x3Arc - xcArc) * RInfo / RArc
                    .Item(3).Y = ycArc + (y3Arc - ycArc) * RInfo / RArc
                End With
                GrCon.Visible = True
                GrCon.Draw
                
                If Abs(R01Dim - RInfo) > GrDim.Properties("$DIMRND") Then
                    With GrDim.Vertices
                        x1Dim = xcArc + (x1Dim - x0Dim) * RInfo / RArc
                        y1Dim = ycArc + (y1Dim - y0Dim) * RInfo / RArc
                        x2Dim = xcArc + (x2Dim - x0Dim) * RInfo / RArc
                        y2Dim = ycArc + (y2Dim - y0Dim) * RInfo / RArc
                        .Item(1).X = x1Dim
                        .Item(1).Y = y1Dim
                        .Item(2).X = x2Dim
                        .Item(2).X = x2Dim
                    End With
                    GrDim.Update
                    GrDim.Draw
                End If
            End If
            RArc = RInfo
        End If
        If GrConType = "TCW50Polyline" Then
            StrInfo = GrDim.Properties("Info")
            StrLen = VBA.Len(StrInfo)
            Str = VBA.Right(StrInfo, StrLen - 1)
            RInfo = CDbl(Str)
            If Abs(RInfo - RArc) > Eps Then
            
                With GrCon.Vertices
                    xcArc = .Item(iVer).X
                    ycArc = .Item(iVer).Y
                    x1Arc = .Item(iVer - 1).X
                    y1Arc = .Item(iVer - 1).Y
                    x2Arc = .Item(iVer + 1).X
                    y2Arc = .Item(iVer + 1).Y
                    x3Arc = .Item(iVer + 2).X
                    y3Arc = .Item(iVer + 2).Y
                    GrCon.Visible = False
                    GrCon.Draw
                    
                    .Item(iVer - 1).X = xcArc + (x1Arc - xcArc) * RInfo / RArc
                    .Item(iVer - 1).Y = ycArc + (y1Arc - ycArc) * RInfo / RArc
                    .Item(iVer + 1).X = xcArc + (x2Arc - xcArc) * RInfo / RArc
                    .Item(iVer + 1).Y = ycArc + (y2Arc - ycArc) * RInfo / RArc
                    .Item(iVer + 2).X = xcArc + (x3Arc - xcArc) * RInfo / RArc
                    .Item(iVer + 2).Y = ycArc + (y3Arc - ycArc) * RInfo / RArc
                End With
                GrCon.Visible = True
                GrCon.Update
                GrCon.Draw
                If Abs(R01Dim - RInfo) > Eps Then
                    With GrDim.Vertices
                        x1Dim = xcArc + (x1Dim - x0Dim) * RInfo / RArc
                        y1Dim = ycArc + (y1Dim - y0Dim) * RInfo / RArc
                        x2Dim = xcArc + (x2Dim - x0Dim) * RInfo / RArc
                        y2Dim = ycArc + (y2Dim - y0Dim) * RInfo / RArc
                        .Item(1).X = x1Dim
                        .Item(1).Y = y1Dim
                        .Item(2).X = x2Dim
                        .Item(2).X = x2Dim
                    End With
                    GrDim.Update
                    GrDim.Draw
                End If
            End If
            RArc = RInfo
        End If
        
        If Abs(xcArc - x0Dim) < Eps And Abs(ycArc - y0Dim) < Eps Then
        Else
            GrDim.Update
            GrDim.Draw
        End If
        GrDim.Vertices(1).Editable = False
        ' Write New Data into TSet Structures
        Set TSets = ActDr.TieSets
        Set TSet = TSets.TieSet(idSbj, idSbd)
            tieData.R = RArc
            tieData.xc = xcArc
            tieData.yc = ycArc
            tieData.x1 = x1Dim
            tieData.y1 = y1Dim
            tieData.x2 = x2Dim
            tieData.y2 = y2Dim
            tieData.iVer = iVer
            tieData.fiRel = fiRel
            varData = tieData
            TSet.AddTie idVTie, 1, varData
        
        Set TSet = TSets.TieSet(idSbd, idSbj)
            tieData.R = RArc
            tieData.xc = xcArc
            tieData.yc = ycArc
            tieData.x1 = x1Dim
            tieData.y1 = y1Dim
            tieData.x2 = x2Dim
            tieData.y2 = y2Dim
            tieData.iVer = iVer
            tieData.fiRel = fiRel
            varData = tieData
            TSet.AddTie idVTie, 1, varData
        
    End If
' ##########################################################################
' ##########################################################################
' ##########################################################################
' ##########################################################################
    
    
    
End Function
