VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CoordTie"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements ITurboCADSmartTieServer

Private Declare Function TCWDrawingActive Lib "TCAPI70.dll" () As Long
Private Declare Function TCWGraphicAt Lib "TCAPI70.dll" (ByVal d As Long, ByVal Index As Long) As Long
Private Declare Function TCWVertexAt Lib "TCAPI70.dll" (ByVal g As Long, ByVal Index As Long) As Long

Private Declare Sub prVertexSetSomeFlags Lib "DBAPI70.dll" (ByVal hVer As Long, ByVal FlagOn As Long, ByVal FlagOff As Long)

Private Declare Function GraphicGetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long) As Long
Private Declare Function GraphicSetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long, ByVal hMat As Long) As Boolean
Private Declare Function MatrixEqual Lib "DBAPI70.dll" (ByVal hM1 As Long, ByVal hM2 As Long) As Boolean

'Useful math constants
Const Pi# = 3.14159265
Const Eps = 0.000001


Public Type VertexTieData
    TypeSeg As Integer  ' 1 - Line
                        ' 2 - Arc
                        ' 3 - ArcSegment
    xLocRelPrev As Double ' Previous local coordinate on line segment
    fiLocRelPrev As Double  ' Previous Angle coordinate on Arc segment
    
    ConVerCount As Long     ' count of vertex on base Graphic
    ConVertex As Long  ' Connected Vertex
    NumSegment As Long  ' Connected Segment
    CoordSum As Double ' sum of Coordinates
End Type

Private idVTie As String

Private TSets As TieSets
Private TSet  As TieSet
Private Tie   As Tie
Private ActDr   As Drawing
Private tieData As VertexTieData
    
Private VersSbj As Vertices
Private VersSbd As Vertices

Private Grs   As Graphics
Private GrSbj As Graphic
Private GrSbd As Graphic

Private hDr As Long
Private hGrSurText As Long
Private hGrBaseLine As Long
Private hMatSurText As Long
Private hMatBaseLine As Long


Private Function Clear()
    
    Set VersSbj = Nothing
    Set VersSbd = Nothing
    
    Set GrSbj = Nothing
    Set GrSbd = Nothing
    Set Grs = Nothing
    Set Tie = Nothing
    Set TSet = Nothing
    Set TSets = Nothing
    Set ActDr = Nothing

End Function


Private Function ITurboCADSmartTieServer_AddTie(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long, ByVal lType As Long) As Boolean
'MsgBox ("AddTie")
Dim varData As Variant
    Set ActDr = pIDispDwg
    Set GrSbj = Nothing
    Set GrSbd = Nothing
    Set GrSbj = ActDr.Graphics.GraphicFromID(idSbj)
    Set GrSbd = ActDr.Graphics.GraphicFromID(idSbd)
Dim GrText As Graphic
Dim GrCon As Graphic
    If GrSbj.Type = "Surveying.CoordReg" Then
        Set GrText = GrSbj
        Set GrCon = GrSbd
    Else
        Set GrText = GrSbd
        Set GrCon = GrSbj
    End If
    
Dim ConVerCount As Long, CoordSum#
    CoordSum = 0
Dim i As Long, xi#, yi#
    With GrCon.Vertices
        ConVerCount = .Count
        For i = 0 To ConVerCount - 1
            xi = .Item(i).X
            yi = .Item(i).Y
            CoordSum = CoordSum + xi + yi
        Next i
    End With
    
Dim ConVertex As Long
    ConVertex = GrText.Properties("ConVertex")
    ConVertex = lType
    
Dim NumSegment As Long
    NumSegment = 0
Dim GrConType$
    GrConType = GrCon.Type
Dim TypeSeg%
    TypeSeg = 1
    If GrConType = "ARC" Then
        TypeSeg = 2     ' Arc
        NumSegment = 1
    Else
        If GrCon.Vertices(ConVertex + 1).Bulge = False Then
            TypeSeg = 1 ' Line segment
        Else
            TypeSeg = 3 ' Arc segment
        End If
        If GrConType = "GRAPHIC" Then
            NumSegment = ConVertex
        Else
Dim Vers As Vertices
Dim Ver As Vertex
Dim VerNext As Vertex

            Set Vers = GrCon.Vertices
            NumSegment = 0
            i = 0
            Set Ver = Vers(i)
            Set VerNext = Vers(i)
            If i = ConVertex Then
                NumSegment = NumSegment + 1
                GoTo LEND
            End If
            If VerNext.Bulge = False Then
                i = i + 1
                NumSegment = NumSegment + 1
                If i = ConVerCount - 1 Then GoTo LEND
            Else
                i = i + 3
                NumSegment = NumSegment + 1
                If i = ConVerCount - 1 Then GoTo LEND
            End If
LEND:
        End If
    End If
    
        
    
    
    
    
Dim x0#, y0#
Dim xB#, yB#, xE#, yE#, xc#, yc#, xDir#, yDir#, xMid#, yMid#
Dim L#, sina#, cosa#, x0Loc#, y0Loc#, R#
Dim xLocRelPrev#
    xLocRelPrev = 0
    With GrText.Vertices
        x0 = .Item(0).X
        y0 = .Item(0).Y
    End With
        
    If TypeSeg = 1 Then ' Line segm
        With GrCon.Vertices
            xB = .Item(ConVertex).X
            yB = .Item(ConVertex).Y
            xE = .Item(ConVertex + 1).X
            yE = .Item(ConVertex + 1).Y
        End With
        L = Sqr((xE - xB) * (xE - xB) + (yE - yB) * (yE - yB))
        sina = (yE - yB) / L
        cosa = (xE - xB) / L
        x0Loc = (y0 - yB) * sina + (x0 - xB) * cosa
        xLocRelPrev = x0Loc
    End If
        
Dim fiB#, fiE#, fi0#
Dim fiBLoc#, fiELoc#, fi0Loc#
Dim fiLocRelPrev#
    fiLocRelPrev = 0
    If TypeSeg = 2 Then ' Arc
        With GrCon.Vertices
            xc = .Item(0).X
            yc = .Item(0).Y
            xB = .Item(1).X
            yB = .Item(1).Y
            xE = .Item(2).X
            yE = .Item(2).Y
            xDir = .Item(3).X
            yDir = .Item(3).Y
        End With
        R = Sqr((xB - xc) * (xB - xc) + (yB - yc) * (yB - yc))
        sina = (yB - yc) / R
        cosa = (xB - xc) / R
        fiB = Angle(sina, cosa)
        sina = (yE - yc) / R
        cosa = (xE - xc) / R
        fiE = Angle(sina, cosa)
        
        If fiB - fiE > Eps Then fiB = fiB - 2 * Pi
        
        sina = (y0 - yc) / R
        cosa = (x0 - xc) / R
        fi0 = Angle(sina, cosa)
        
        fiBLoc = fiB - fiB
        fiELoc = fiE - fiB
        fi0Loc = fi0 - fiB
        fiLocRelPrev = fi0Loc
    End If
    If TypeSeg = 3 Then ' Arc segment
        With GrCon.Vertices
            xc = .Item(ConVertex + 1).X
            yc = .Item(ConVertex + 1).Y
            xB = .Item(ConVertex).X
            yB = .Item(ConVertex).Y
            xE = .Item(ConVertex + 3).X
            yE = .Item(ConVertex + 3).Y
            xDir = .Item(ConVertex + 2).X
            yDir = .Item(ConVertex + 2).Y
        End With
        R = Sqr((xB - xc) * (xB - xc) + (yB - yc) * (yB - yc))
Dim Rot%
        Rot = ArcRotation(xB, yB, xDir, yDir, xc, yc, R)
        sina = (yB - yc) / R
        cosa = (xB - xc) / R
        fiB = Angle(sina, cosa)
        sina = (yE - yc) / R
        cosa = (xE - xc) / R
        fiE = Angle(sina, cosa)
        
        If fiB - fiE > Eps Then fiB = fiB - 2 * Pi
        
        sina = (y0 - yc) / R
        cosa = (x0 - xc) / R
        fi0 = Angle(sina, cosa)
        
        fiBLoc = fiB - fiB
        fiELoc = fiE - fiB
        fi0Loc = fi0 - fiB
        fiLocRelPrev = fi0Loc
    
    End If
    Set TSets = ActDr.TieSets
    Set TSet = TSets.TieSet(idSbj, idSbd)
        tieData.ConVerCount = ConVerCount
        tieData.CoordSum = CoordSum
        tieData.fiLocRelPrev = fiLocRelPrev
        tieData.TypeSeg = TypeSeg
        tieData.xLocRelPrev = xLocRelPrev
        tieData.ConVertex = ConVertex
        tieData.NumSegment = NumSegment
        varData = tieData
        TSet.AddTie idVTie, 1, varData
    
    Set TSet = TSets.TieSet(idSbd, idSbj)
        tieData.ConVerCount = ConVerCount
        tieData.CoordSum = CoordSum
        tieData.fiLocRelPrev = fiLocRelPrev
        tieData.TypeSeg = TypeSeg
        tieData.xLocRelPrev = xLocRelPrev
        tieData.ConVertex = ConVertex
        tieData.NumSegment = NumSegment
        varData = tieData
        TSet.AddTie idVTie, 1, varData
        varData = tieData
        TSet.AddTie idVTie, 1, varData
        
        Set GrText = Nothing
        Set GrCon = Nothing
    ITurboCADSmartTieServer_AddTie = True
    Clear

End Function

Private Function ITurboCADSmartTieServer_CopyTie(ByVal pIDispDwg As Object, ByVal idSbjSrc As Long, ByVal idSbdSrc As Long, ByVal idSbjTrg As Long, ByVal idSbdTrg As Long) As Boolean
    
    Set ActDr = pIDispDwg
    Set Grs = ActDr.Graphics
    Set GrSbj = Grs.GraphicFromID(idSbjTrg)
    Set GrSbd = Grs.GraphicFromID(idSbdTrg)
    
    Set TSets = ActDr.TieSets
    Set TSet = TSets.TieSet(idSbjSrc, idSbdSrc)
    Set Tie = TSet(0)
    tieData = Tie.Data
    
'    TSets.Add idVTie, GrSbj, GrSbd, tieData.idVrtSbj, 0, TSet
    
    Set Tie = TSet(0)
    Tie.Data = tieData
    
    Clear

    ITurboCADSmartTieServer_CopyTie = True
End Function

Private Function ITurboCADSmartTieServer_DeleteTie(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long, ByVal pIDsipGr As Object) As Boolean
    ITurboCADSmartTieServer_DeleteTie = True
End Function

Private Property Get ITurboCADSmartTieServer_Description() As String
    ITurboCADSmartTieServer_Description = "CurveText_Tie"
End Property

Private Function ITurboCADSmartTieServer_GetIDs(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long) As Variant
' It is not need to do something here because this method doesn't use Graphic's DataBase ID
End Function

Private Function ITurboCADSmartTieServer_GetTypesInfo(Names As Variant, Types As Variant) As Long
    ITurboCADSmartTieServer_GetTypesInfo = 0
End Function

Private Function ITurboCADSmartTieServer_Initialize(ByVal ThisTieMethod As Object) As Boolean
    Dim gxTMethod As TieMethod
    Set gxTMethod = ThisTieMethod
    idVTie = gxTMethod.Name
    ITurboCADSmartTieServer_Initialize = True
End Function


Private Sub ITurboCADSmartTieServer_SetIDs(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long, pvarIDs As Variant)
' It is not need to do something here because this method doesn't use Graphic's DataBase ID
End Sub

Private Function ITurboCADSmartTieServer_TieCanNODEED(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long) As Boolean
    ITurboCADSmartTieServer_TieCanNODEED = True
End Function

Private Function ITurboCADSmartTieServer_UpdateTie(ByVal pIDispDwg As Object, ByVal idSbj As Long, ByVal idSbd As Long) As Integer
    
    Set ActDr = pIDispDwg
    
    Set TSets = ActDr.TieSets
    Set TSet = TSets.TieSet(idSbj, idSbd)

    UpdateTie TSet, TSets, idSbj, idSbd


    ITurboCADSmartTieServer_UpdateTie = 0
    Clear

End Function


Private Function Angle(sinb As Double, cosb As Double) As Double

        If Abs(cosb) < 0.0001 Then
            If sinb > 0 Then
                Angle = Pi / 2
            Else
                Angle = 3 * Pi / 2
            End If
        Else
            If sinb >= 0 And cosb > 0 Then Angle = Atn(sinb / cosb)
            If sinb >= 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb > 0 Then Angle = 2 * Pi + Atn(sinb / cosb)
        End If
End Function

' Define the direction of Arc rotation
' return ArcRotation = 1 if CounterClockwise
' return ArcRotation = -1 if Clockwise

Private Function ArcRotation(xB As Double, yB As Double, xDir As Double, yDir As Double, xc As Double, yc As Double, R As Double) As Integer
Dim sina#, cosa# ', Alp0#, Alp1#
    sina = (yB - yc) / R
    cosa = (xB - xc) / R
Dim xLoc#, yLoc#
    xLoc = (yDir - yc) * sina + (xDir - xc) * cosa
    yLoc = (yDir - yc) * cosa - (xDir - xc) * sina
    If yLoc > 0 Then
        ArcRotation = -1
    Else
        ArcRotation = 1
    End If
End Function






Private Function UpdateTie(ByRef TSet As TieSet, ByRef TSets As TieSets, ByVal idSbj As Long, ByVal idSbd As Long)

    Dim varData As Variant
    Set ActDr = TSets.Drawing
    Set GrSbj = Nothing
    Set GrSbd = Nothing
    Set GrSbj = ActDr.Graphics.GraphicFromID(idSbj)
    Set GrSbd = ActDr.Graphics.GraphicFromID(idSbd)
Dim GrText As Graphic
Dim GrCon As Graphic
Dim EditGr$
    If GrSbj.Type = "Surveying.CoordReg" Then
        Set GrText = GrSbj
        Set GrCon = GrSbd
        EditGr = "Text"
    Else
        Set GrText = GrSbd
        Set GrCon = GrSbj
        EditGr = "Base"
    End If

    
    Set Tie = TSet(0)
    varData = Tie.Data
    tieData = varData(0)
    
Dim ConVerCount As Long, CoordSum#, fiLocRelPrev#, TypeSeg%, xLocRelPrev#
Dim ConVertex As Long, NumSegment As Long
    ConVerCount = tieData.ConVerCount
    CoordSum = tieData.CoordSum
    fiLocRelPrev = tieData.fiLocRelPrev
    TypeSeg = tieData.TypeSeg
    xLocRelPrev = tieData.xLocRelPrev
    ConVertex = tieData.ConVertex
    NumSegment = tieData.NumSegment
    
    '#################################################################
    '#################################################################
    '#################################################################
    ' if was edited - TEXT
    ConVertex = GrText.Properties("ConVertex")
Dim Ver As Vertex
Dim VerNext As Vertex
Dim x0#, y0#
Dim xB#, yB#, xE#, yE#, xc#, yc#, xDir#, yDir#, xMid#, yMid#
Dim L#, sina#, cosa#, x0Loc#, y0Loc#, R#

    If EditGr = "Text" Then
        Set Ver = Nothing
        On Error Resume Next
        Set Ver = GrCon.Vertices(ConVertex)
        If Ver Is Nothing Then
            GoTo QQQ
        End If
        
        Set VerNext = Nothing
        On Error Resume Next
        Set VerNext = GrCon.Vertices(ConVertex + 1)
        If VerNext Is Nothing Then
            GoTo QQQ
        End If
        
'Dim xmax#, ymax#, xmin#, ymin#
'        With GrText.CalcBoundingBox
'            xmax = .Max.X
'            ymax = .Max.Y
'            xmin = .Min.X
'            ymin = .Min.Y
'        End With
' Dim GrRect As Graphic
'        Set GrRect = ActDr.Graphics.Add(11)
'        With GrRect.Vertices
'            .Add xmin, ymin, 0
'            .Add xmax, ymin, 0
'            .Add xmax, ymax, 0
'            .Add xmin, ymax, 0
'            .AddClose
'        End With
'        GrRect.Properties("PenColor") = RGB(255, 255, 255)
'        GrRect.Draw
        
'        GrText.Properties("GrConID") = GrCon.ID
        
'        GrText.Update
'        GrText.Draw
'        GrRect.Deleted = True
                
        
        If GrCon.Type = "ARC" Then
            TypeSeg = 2
        Else
            If VerNext.Bulge = True Then
                TypeSeg = 3
            Else
                TypeSeg = 1
            End If
        End If
        
        With GrText.Vertices
            x0 = .Item(0).X
            y0 = .Item(0).Y
        End With
        ' ***********************************************************
        
        If TypeSeg = 1 Then
            With GrCon.Vertices
                xB = .Item(ConVertex).X
                yB = .Item(ConVertex).Y
                xE = .Item(ConVertex + 1).X
                yE = .Item(ConVertex + 1).Y
            End With
            L = Sqr((xE - xB) * (xE - xB) + (yE - yB) * (yE - yB))
            sina = (yE - yB) / L
            cosa = (xE - xB) / L
            x0Loc = (y0 - yB) * sina + (x0 - xB) * cosa
            xLocRelPrev = x0Loc
        End If
        ' ***********************************************************
Dim fiB#, fiE#, fi0#
Dim fiBLoc#, fiELoc#, fi0Loc#
        If TypeSeg = 2 Then ' Arc
            With GrCon.Vertices
                xc = .Item(0).X
                yc = .Item(0).Y
                xB = .Item(1).X
                yB = .Item(1).Y
                xE = .Item(2).X
                yE = .Item(2).Y
                xDir = .Item(3).X
                yDir = .Item(3).Y
            End With
            R = Sqr((xB - xc) * (xB - xc) + (yB - yc) * (yB - yc))
            sina = (yB - yc) / R
            cosa = (xB - xc) / R
            fiB = Angle(sina, cosa)
            sina = (yE - yc) / R
            cosa = (xE - xc) / R
            fiE = Angle(sina, cosa)
            
            If fiB - fiE > Eps Then fiB = fiB - 2 * Pi
            
            sina = (y0 - yc) / R
            cosa = (x0 - xc) / R
            fi0 = Angle(sina, cosa)
            
            fiBLoc = fiB - fiB
            fiELoc = fiE - fiB
            fi0Loc = fi0 - fiB
            fiLocRelPrev = fi0Loc
        End If
        ' ***********************************************************
        If TypeSeg = 3 Then ' Arc segment
            With GrCon.Vertices
                xc = .Item(ConVertex + 1).X
                yc = .Item(ConVertex + 1).Y
                xB = .Item(ConVertex).X
                yB = .Item(ConVertex).Y
                xE = .Item(ConVertex + 3).X
                yE = .Item(ConVertex + 3).Y
                xDir = .Item(ConVertex + 2).X
                yDir = .Item(ConVertex + 2).Y
            End With
            R = Sqr((xB - xc) * (xB - xc) + (yB - yc) * (yB - yc))
Dim Rot%
            Rot = ArcRotation(xB, yB, xDir, yDir, xc, yc, R)
            sina = (yB - yc) / R
            cosa = (xB - xc) / R
            fiB = Angle(sina, cosa)
            sina = (yE - yc) / R
            cosa = (xE - xc) / R
            fiE = Angle(sina, cosa)
            
            If fiB - fiE > Eps Then fiB = fiB - 2 * Pi
            
            sina = (y0 - yc) / R
            cosa = (x0 - xc) / R
            fi0 = Angle(sina, cosa)
            
            fiBLoc = fiB - fiB
            fiELoc = fiE - fiB
            fi0Loc = fi0 - fiB
            fiLocRelPrev = fi0Loc
        End If
        
        ' Write New Data into TSet Structures
        Set TSets = ActDr.TieSets
        Set TSet = TSets.TieSet(idSbj, idSbd)
            tieData.ConVerCount = ConVerCount
            tieData.CoordSum = CoordSum
            tieData.fiLocRelPrev = fiLocRelPrev
            tieData.TypeSeg = TypeSeg
            tieData.xLocRelPrev = xLocRelPrev
            tieData.ConVertex = ConVertex
            tieData.NumSegment = NumSegment
            varData = tieData
            TSet.AddTie idVTie, 1, varData
        
        Set TSet = TSets.TieSet(idSbd, idSbj)
            tieData.ConVerCount = ConVerCount
            tieData.CoordSum = CoordSum
            tieData.fiLocRelPrev = fiLocRelPrev
            tieData.TypeSeg = TypeSeg
            tieData.xLocRelPrev = xLocRelPrev
            tieData.ConVertex = ConVertex
            tieData.NumSegment = NumSegment
            varData = tieData
            TSet.AddTie idVTie, 1, varData
    End If
    '#################################################################
    '#################################################################
    '#################################################################
        
    '#################################################################
    '#################################################################
    '#################################################################
    ' if was edited - BASE-graphic

    
    If EditGr = "Base" Then
        Set Ver = Nothing
        On Error Resume Next
        Set Ver = GrCon.Vertices(ConVertex)
        If Ver Is Nothing Then
            GoTo QQQ
        End If
        Set VerNext = Nothing
        On Error Resume Next
        Set VerNext = GrCon.Vertices(ConVertex + 1)
        If VerNext Is Nothing Then
            GoTo QQQ
        End If
Dim xmax#, ymax#, xmin#, ymin#
        With GrText.CalcBoundingBox
            xmax = .Max.X
            ymax = .Max.Y
            xmin = .Min.X
            ymin = .Min.Y
        End With
 Dim GrRect As Graphic
        Set GrRect = ActDr.Graphics.Add(11)
        With GrRect.Vertices
            .Add xmin, ymin, 0
            .Add xmax, ymin, 0
            .Add xmax, ymax, 0
            .Add xmin, ymax, 0
            .AddClose
        End With
        GrRect.Properties("PenColor") = RGB(255, 255, 255)
        GrRect.Draw
        
        
        If GrCon.Type = "ARC" Then
            TypeSeg = 2
        Else
            If VerNext.Bulge = True Then
                TypeSeg = 3
            Else
                TypeSeg = 1
            End If
        End If

        With GrText.Vertices
            x0 = .Item(0).X
            y0 = .Item(0).Y
        End With
        
        ' ***********************************************************
        If TypeSeg = 1 Then
            With GrCon.Vertices
                xB = .Item(ConVertex).X
                yB = .Item(ConVertex).Y
                xE = .Item(ConVertex + 1).X
                yE = .Item(ConVertex + 1).Y
            End With
            L = Sqr((xE - xB) * (xE - xB) + (yE - yB) * (yE - yB))
            sina = (yE - yB) / L
            cosa = (xE - xB) / L
            
            x0Loc = xLocRelPrev
            y0Loc = 0
            x0 = xB + x0Loc * cosa - y0Loc * sina
            y0 = yB + x0Loc * sina + y0Loc * cosa
            With GrText.Vertices
                .Item(0).X = x0
                .Item(0).Y = y0
            End With
            GrText.Update
            GrText.Draw
        End If
        ' *******************************************************
        If TypeSeg = 2 Then ' Arc
            With GrCon.Vertices
                xc = .Item(0).X
                yc = .Item(0).Y
                xB = .Item(1).X
                yB = .Item(1).Y
            End With
            R = Sqr((xB - xc) * (xB - xc) + (yB - yc) * (yB - yc))
            sina = (yB - yc) / R
            cosa = (xB - xc) / R
            fiB = Angle(sina, cosa)
            
            If fiB - fiE > Eps Then fiB = fiB - 2 * Pi
            
            fi0 = fiB + fiLocRelPrev
            
            x0 = xc + R * Cos(fi0)
            y0 = yc + R * Sin(fi0)
            With GrText.Vertices
                .Item(0).X = x0
                .Item(0).Y = y0
            End With
            GrText.Update
            GrText.Draw
        End If
        ' ***********************************************************
        If TypeSeg = 3 Then ' Arc segment
            With GrCon.Vertices
                xc = .Item(ConVertex + 1).X
                yc = .Item(ConVertex + 1).Y
                xB = .Item(ConVertex).X
                yB = .Item(ConVertex).Y
                xE = .Item(ConVertex + 3).X
                yE = .Item(ConVertex + 3).Y
                xDir = .Item(ConVertex + 2).X
                yDir = .Item(ConVertex + 2).Y
            End With
            R = Sqr((xB - xc) * (xB - xc) + (yB - yc) * (yB - yc))
            Rot = ArcRotation(xB, yB, xDir, yDir, xc, yc, R)
            sina = (yB - yc) / R
            cosa = (xB - xc) / R
            fiB = Angle(sina, cosa)
            
            If fiB - fiE > Eps Then fiB = fiB - 2 * Pi
            
            fi0 = fiB + fiLocRelPrev
            
            x0 = xc + R * Cos(fi0)
            y0 = yc + R * Sin(fi0)
            With GrText.Vertices
                .Item(0).X = x0
                .Item(0).Y = y0
            End With
            GrText.Update
            GrText.Draw
        
        End If
        GrRect.Deleted = True

    End If
    
QQQ:
'    GrText.Properties("GrConID") = -1
'    GrText.Draw
    Set GrText = Nothing
    Set GrCon = Nothing
End Function

