VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InsertTool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Number of tools in this server
Const NUM_TOOLS = 1


' *******************************************************************
'    Const EventMask = 268435456 + 536870912
'    Const EventMask = 1024 + 268435456 + 536870912
    Const EventMask = 1 + 2 + 4 + 8 + 16 + 32 + 64 + 1024 + 4096 + 262144 + 268435456 + 536870912

    Private iConnectId As Long
    Private iActTool As Long
    Private theToolEvents As IToolEvents


' *******************************************************************
'Toggle this to test loading buttons from .Bmp/.Res
Const boolLoadFromBmp As Boolean = False
Const boolDebug As Boolean = False
'##########################################################################
'##########################################################################
Private Declare Function TCWUndoClear Lib "TCAPI70.dll" () As Long
Private Declare Function TCWUndoRecordEnd Lib "TCAPI70.dll" (ByVal d As Long) As Long
Private Declare Function TCWUndoRecordStart Lib "TCAPI70.dll" (ByVal d As Long, ByRef Title As String) As Long
Private Declare Function TCWUndoRecordAddGraphic Lib "TCAPI70.dll" (ByVal d As Long, ByVal g As Long) As Long
Private Declare Function TCWUndo Lib "TCAPI70.dll" (ByVal N As Long) As Long

Private Declare Function TCWDrawingActive Lib "TCAPI70.dll" () As Long
Private Declare Function TCWGraphicAt Lib "TCAPI70.dll" (ByVal d As Long, ByVal Index As Long) As Long
Private Declare Function TCWVertexAt Lib "TCAPI70.dll" (ByVal g As Long, ByVal Index As Long) As Long

Private Declare Sub prVertexSetSomeFlags Lib "DBAPI70.dll" (ByVal hVer As Long, ByVal FlagOn As Long, ByVal FlagOff As Long)

Private Declare Function GraphicGetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long) As Long
Private Declare Function GraphicSetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long, ByVal hMat As Long) As Boolean
Private Declare Function MatrixEqual Lib "DBAPI70.dll" (ByVal hM1 As Long, ByVal hM2 As Long) As Boolean

Private Declare Function TCWViewRedraw Lib "TCAPI70.dll" () As Long

Private hDr As Long
Private GrCon As Graphic

'Copy a windows bitmap of the requested size to the clipboard
'Bitmaps returned should contain NUM_TOOLS images
'Size of entire bitmap:
'Normal:  (NUM_TOOLS*16) wide x 15 high
'Large:   (NUM_TOOLS*24) wide x 23 high
'Mono bitmap should be 1-bit (black or white)
Public Function CopyBitmap(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Boolean
    On Error GoTo BitmapError

    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        'Put the image on the Windows clipboard
        Clipboard.SetData TheImage, vbCFDIB
        CopyBitmap = True
        Exit Function
    End If

BitmapError:
    CopyBitmap = False
End Function

'Return a Picture object for the requested size
'Apparently, returning references to StdPicture objects doesn't work for .EXE servers
'Bitmaps returned should contain NUM_TOOLS images
'Size of entire image:
'Normal:  (NUM_TOOLS*16) wide x 15 high
'Large:   (NUM_TOOLS*24) wide x 23 high
'Mono image should be 1-bit (black or white)
Public Function GetPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Object
    On Error GoTo PictureError

    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        Set GetPicture = TheImage
        Exit Function
    End If

PictureError:
    Set GetPicture = Nothing
End Function

'Implementation specific stuff
'Private function to return the bitmap from .Res file or .Bmp file
Private Function GetButtonPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean, TheImage As StdPicture) As Boolean
    On Error GoTo LoadError

    'There are two ways to load images:  from .Bmp file(s) or from .RES resource.
    'In this demo, we control the loading by a private variable.
    
    'Note that if you are loading from .Bmp, or if you are running this tool as a
    '.VBP for debugging, you must place the .Res or .Bmp files in the Draggers subdirectory
    'of the directory in which TCW40.EXE (or IMSIGX40.DLL) is located.

    If boolLoadFromBmp Then
        'Load from .Bmp file
        Dim strFileName As String 'File name of .Bmp file to load

        If LargeImage Then
            strFileName = App.Path & "\button24.bmp"
        Else
            strFileName = App.Path & "\button16.bmp"
        End If
        Set TheImage = LoadPicture(strFileName)
    Else
        'Load from .Res file
        Dim idBitmap%  'BITMAP resource id in .Res file

        If LargeImage Then
            idBitmap% = 1002
        Else
            idBitmap% = 1001
        End If
        Set TheImage = LoadResPicture(idBitmap%, vbResBitmap)
    End If

    'Return the image
    GetButtonPicture = True
    Exit Function

LoadError:
    If boolDebug Then
'        MsgBox "Error loading bitmap: " & Err.Description
    End If
    GetButtonPicture = False
End Function


'##########################################################################
'##########################################################################
'##########################################################################


'Return a description string for this package of tools
Public Property Get Description() As String
    Description = "SurvCoordTool"
End Property

'Called to perform tool function
Public Function Run(ByVal Tool As Object) As Boolean
    On Error GoTo ErrorHandler
Dim theXTool As Tool
    Set theXTool = Tool
'    theXTool.Application.ActiveDrawing.Graphics.Unselect
    
    Set GrCon = Nothing
    If iConnectId <> -1 Then
        objApp.DisconnectEvents iConnectId
        AddLM False
        iConnectId = -1
        iActTool = -1
        theToolEvents.ToolChangePrompt Me, "", False
    Else
        theToolEvents.ToolChangePrompt Me, "", False
        iConnectId = objApp.ConnectEvents(Me, EventMask)
        iActTool = theXTool.Index
        AddLM True
        theToolEvents.ToolChangePrompt Me, "Click on some graphic", False
    End If

    
    Exit Function
ErrorHandler:
'    MsgBox Err.Msg
    Call Finish
End Function




'Fill arrays with information about tools in the package
'Return the number of tools in the package
Public Function GetToolInfo(CommandNames As Variant, MenuCaptions As Variant, StatusPrompts As Variant, _
    ToolTips As Variant, Enabled As Variant, WantsUpdates As Variant) As Long

    ReDim CommandNames(NUM_TOOLS)
    ReDim MenuCaptions(NUM_TOOLS)
    ReDim StatusPrompts(NUM_TOOLS)
    ReDim ToolTips(NUM_TOOLS)
    ReDim Enabled(NUM_TOOLS)
    ReDim WantsUpdates(NUM_TOOLS)
    CommandNames(0) = "SDK|SurveourCoordinate"
    MenuCaptions(0) = "&SurveourCoordinate"
    ToolTips(0) = "SurveourCoordinate"
    Enabled(0) = True
    WantsUpdates(0) = False
    GetToolInfo = NUM_TOOLS
End Function



'Returns true if tool is correctly initialized
Public Function Initialize(ByVal Tool As Object) As Boolean
On Error GoTo ErrorHandler
    Set objApp = Tool.Application
    Set theToolEvents = objApp
    iConnectId = -1
    iActTool = -1
    Initialize = True
    Exit Function
ErrorHandler:
 '   MsgBox Err.Description
End Function

'Returns true if tool is correctly initialized
Public Function UpdateToolStatus(ByVal Tool As Object, Enabled As Boolean, Checked As Boolean) As Boolean
    Enabled = True 'Could do a test here to determine whether to disable the button/menu item
    If iConnectId = -1 Then
        Checked = False  'Could do a test here to determine whether to check the button/menu item
    Else
        Checked = True
    End If
    UpdateToolStatus = True
End Function


Public Function RunTool(WhichTool As Tool)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function



Public Function BeforeExit(WhichApplication As Application, Cancel As Boolean)
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    Call Finish

End Function
Public Function DrawingNew(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    
    Call Finish
End Function
Public Function DrawingOpen(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingActivate(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingDeactivate(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingBeforeClose(WhichDrawing As Drawing, Cancel As Boolean)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingBeforeSave(WhichDrawing As Drawing, SaveAs As Boolean, Cancel As Boolean)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    Call Finish
End Function



Public Function MouseDown(WhichDrawing As Drawing, WhichView As View, WhichWindow As Window, Button As ImsiMouseButton, Shift As Long, x As Long, y As Long, Cancel As Boolean)
Dim xView#, yView#
On Error GoTo ErrorHandler
    Set Drs = objApp.Drawings
    Set ActDr = WhichDrawing
    Set Grs = ActDr.Graphics
    Set Vis = ActDr.Views
    Set Vi = WhichView
    hDr = TCWDrawingActive
Dim Res As Boolean
    Vi.ScreenToView x, y, xView, yView
    
    If Button = imsiLeftButton Then
        Cancel = True
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        Res = SelectCurve(xView, yView)
        If Res = False Then
MsgBox "The selection object is not valid for this operation.", , "Surveour Dimension"
            theToolEvents.ToolChangePrompt Me, "", False
            theToolEvents.ToolChangePrompt Me, "Click on some graphic", False
            Exit Function
        End If
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
        If iConnectId <> -1 Then
            theToolEvents.ToolChangePrompt Me, "", False
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
            AddLM False
        End If
        Cancel = True
        Call Finish
    Else
        Cancel = False
    End If
'    Call Finish
    Exit Function
ErrorHandler:
    If iConnectId <> -1 Then
        theToolEvents.ToolChangePrompt Me, "", False
        objApp.DisconnectEvents iConnectId
        iConnectId = -1
        AddLM False
    End If
    Call Finish
 '   MsgBox Err.Description
End Function

Public Function Cancel(DoItPlease As Boolean, CanCancel As Boolean)
    If (DoItPlease) Then
        If iConnectId <> -1 Then
            theToolEvents.ToolChangePrompt Me, "", False
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
        End If
                
        theToolEvents.ToolChangePrompt Me, "", False
        Call Finish
    End If

    CanCancel = True
End Function

Public Function UpdateUndo(AllowsUndo As Boolean)
    AllowsUndo = False
End Function

Private Function AddActToolLM(iTool As Long, bAdd As Boolean)
'    AddLM bAdd
End Function
Private Sub Class_Terminate()
    If (Not theToolEvents Is Nothing) Then
        Set theToolEvents = Nothing
    End If
    If (Not objApp Is Nothing) Then
        Set objApp = Nothing
    End If
    
End Sub



Private Function AddLM(bAdd As Boolean)
Dim Captions(0 To 0) As String
Dim Prompts(0 To 0) As String
Dim Enabled(0 To 0) As Boolean
Dim Checked(0 To 0) As Boolean

Dim varCaptions As Variant
Dim varPrompts As Variant
Dim varEnabled As Variant
Dim varChecked As Variant

    If (bAdd) Then
        Captions(0) = "Finish TextAlongCurve"
        Prompts(0) = "Finish TextAlongCurve"
        Enabled(0) = True
        Checked(0) = False
        varCaptions = Captions
        varPrompts = Prompts
        varEnabled = Enabled
        varChecked = Checked
        
        theToolEvents.ToolChangeCommands Me, 1, varCaptions, varPrompts, varEnabled, varChecked, True
    Else
        theToolEvents.ToolChangeCommands Me, 0, , , , , False
    End If
End Function

Public Function DoLMCommand(CmdInd As Long)
'MsgBox ("CmdInd=" & CStr(CmdInd))
   If CmdInd = 0 Then
         If iConnectId <> -1 Then
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
            AddLM False
        End If
        theToolEvents.ToolChangePrompt Me, "", False
      
        Call Finish
'        Set objApp = Nothing
        
    End If

End Function
Private Sub Finish()
    Set GrCon = Nothing
    Set Grs = Nothing
    Set Vi = Nothing
    Set Vis = Nothing
    Set ActDr = Nothing
    Set Drs = Nothing
 '   Set objApp = Nothing
End Sub




'########################################################################
'########################################################################
'########################################################################
' Select Curve at Mouse click

Private Function SelectCurve(xCl As Double, yCl As Double) As Boolean
On Error GoTo ErrorHandler

Dim PicRes As PickResult
Dim PicCount As Long
    ActDr.Application.SnapModes = 256 ' Nearest to graphic
    Set PicRes = Vi.PickPoint(xCl, yCl, 0.2)
    PicCount = PicRes.Count
    
    If PicCount = 0 Then
        ActDr.Application.SnapModes = 1 ' Nearest to graphic
        SelectCurve = False
        Exit Function
    End If
    
    Set GrCon = PicRes(0).Graphic
Dim GrConType$, GrConID As Long
    GrConType = GrCon.Type
    If GrConType = "GRAPHIC" Or GrConType = "ARC" Or GrConType = "TCW50Polyline" Then
        GrConID = GrCon.ID
    Else
        ActDr.Application.SnapModes = 1 ' Nearest to graphic
        SelectCurve = False
        Set PicRes = Nothing
        Exit Function
    End If
    
    If GrConType = "GRAPHIC" And GrCon.Graphics.Count > 0 Then
        ActDr.Application.SnapModes = 1 ' Nearest to graphic
        SelectCurve = False ' Clicked graphic can't take part in operation
        Set PicRes = Nothing
        Exit Function
    End If
    If GrConType = "GRAPHIC" And ActDr.Properties("TileMode") = 1 Then
Dim Thick1#
        Thick1 = -1000000#
        On Error Resume Next
        Thick1 = GrCon.Properties("Thickness")
        If Thick1 = -1000000 Then ' For 3D-Polyline
            ActDr.Application.SnapModes = 1 ' Nearest to graphic
            SelectCurve = False ' Clicked graphic can't take part in operation
            Set PicRes = Nothing
            Exit Function
        End If
    End If
    If GrConType = "TCW50Polyline" Then
'MsgBox (GrCon.Graphics(0).Name)
        If GrCon.Graphics(0).Name = "ChildWithWidth" Or GrCon.Graphics(0).Name = "Line_Width_Cosmetic" Then
            ActDr.Application.SnapModes = 1 ' Nearest to graphic
            SelectCurve = False ' Clicked graphic can't take part in operation
            Set PicRes = Nothing
            Exit Function
        End If
    End If
    If ActDr.Properties("TileMode") = 1 Then
        Thick1 = GrCon.Properties("Thickness")
        If Thick1 <> 0 Then
            ActDr.Application.SnapModes = 1 ' Nearest to graphic
            SelectCurve = False ' Clicked graphic can't take part in operation
            Set PicRes = Nothing
            Exit Function
        End If
    End If
    
Dim GrText As Graphic
    Set GrText = Grs.Add(, "Surveying.CoordReg")
Dim hGrText As Long
    hGrText = TCWGraphicAt(hDr, GrText.Index)
    TCWUndoRecordStart hDr, "Add Surveour Coordinate"
    TCWUndoRecordAddGraphic hDr, hGrText
    TCWUndoRecordEnd hDr
    
Dim hGrCon As Long, hMat As Long
    hGrCon = TCWGraphicAt(hDr, GrCon.Index)
    hMat = GraphicGetMatrix(hGrCon)
    GraphicSetMatrix hGrText, hMat
    
Dim xPic#, yPic#
Dim Ver As Vertex
        Set Ver = PicRes(0).ClosestVertex
        xPic = Ver.x
        yPic = Ver.y
        
Dim nV As Long, i As Long
Dim xi#, yi#, xi1#, yi1#
Dim l#, sina#, cosa#
Dim xLoc#, yLoc#
Dim iPrev As Long
    iPrev = 0
    If GrConType = "GRAPHIC" Then
        nV = GrCon.Vertices.Count
        If nV = 2 Then
            GrText.Properties("ConVertex") = 0
        Else
            With GrCon.Vertices
                For i = 0 To nV - 2
                    xi = .Item(i).x
                    yi = .Item(i).y
                    xi1 = .Item(i + 1).x
                    yi1 = .Item(i + 1).y
                    l = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                    sina = (yi1 - yi) / l
                    cosa = (xi1 - xi) / l
                    yLoc = (yPic - yi) * cosa - (xPic - xi) * sina
                    xLoc = (yPic - yi) * sina + (xPic - xi) * cosa
                    If xLoc > 0 And xLoc < l And Abs(yLoc) < Eps Then
                        iPrev = i
                        Exit For
                    End If
                Next i
            End With
            GrText.Properties("ConVertex") = iPrev
        End If
    End If
    If GrConType = "ARC" Then
        GrText.Properties("ConVertex") = 0
    End If
    
    
    
    
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    If GrConType = "TCW50Polyline" Then
        iPrev = PreviousVertex(GrConType, GrCon, xPic, yPic)
'MsgBox ("iPrev=" & CStr(iPrev))
            
        GrText.Properties("ConVertex") = iPrev
    End If
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    
    
    
    GrText.Properties("GrConID") = GrConID
    GrText.Properties("GrConType") = GrConType
    GrText.Update
    ActDr.Application.SnapModes = 1 ' Nearest to graphic
    
    
    
Dim TSets As TieSets
    Set TSets = ActDr.TieSets
    TSets.Add "Surveying.CoordTie", GrCon, GrText, iPrev, 0
    
    GrText.Draw
    Set GrText = Nothing
    Set PicRes = Nothing
    Set TSets = Nothing
    SelectCurve = True
    
    Exit Function
ErrorHandler:
    Set GrText = Nothing
    Set PicRes = Nothing
    Set TSets = Nothing
    SelectCurve = False
    ActDr.Application.SnapModes = 1 ' Nearest to graphic

End Function

' Define number of previous vertices for Base graphic

Private Function PreviousVertex(GrConType As String, GrCon As Graphic, xPic As Double, yPic As Double)

Dim i As Long
Dim nVCon As Long
        nVCon = GrCon.Vertices.Count
Dim nVCosm As Long
        nVCosm = GrCon.Graphics(0).Vertices.Count
        
Dim GrConInfo As GrInfo
        GrConInfo.nV = nVCon
ReDim GrConInfo.xVer(nVCon)
ReDim GrConInfo.yVer(nVCon)
Dim ArcCount As Long
Dim iBaseArcBeg(100) As Long
Dim iBaseArcEnd(100) As Long
        ArcCount = 0
        With GrCon.Vertices
            For i = 0 To nVCon - 1
                GrConInfo.xVer(i) = .Item(i).x
                GrConInfo.yVer(i) = .Item(i).y
            Next i
            For i = 0 To nVCon - 2
                If .Item(i).Bulge = False And .Item(i + 1).Bulge = True Then
                    iBaseArcBeg(ArcCount) = i
                    iBaseArcEnd(ArcCount) = i + 3
                    ArcCount = ArcCount + 1
                End If
            Next i
        End With
        
Dim GrCosmInfo As GrInfo
        GrCosmInfo.nV = nVCosm
ReDim GrCosmInfo.xVer(nVCosm)
ReDim GrCosmInfo.yVer(nVCosm)
        With GrCon.Graphics(0).Vertices
            For i = 0 To nVCosm - 1
                GrCosmInfo.xVer(i) = .Item(i).x
                GrCosmInfo.yVer(i) = .Item(i).y
            Next i
        End With
        
Dim iCosmArcBeg(100) As Long
Dim iCosmArcEnd(100) As Long
Dim j As Long, xi#, yi#, xj#, yj#

        For i = 0 To ArcCount - 1
            xi = GrConInfo.xVer(iBaseArcBeg(i))
            yi = GrConInfo.yVer(iBaseArcBeg(i))
            For j = 0 To nVCosm - 1
                xj = GrCosmInfo.xVer(j)
                yj = GrCosmInfo.yVer(j)
                If Abs(xi - xj) < Eps And Abs(yi - yj) < Eps Then
                    iCosmArcBeg(i) = j
                    Exit For
                End If
            Next j
            
            xi = GrConInfo.xVer(iBaseArcEnd(i))
            yi = GrConInfo.yVer(iBaseArcEnd(i))
            For j = 0 To nVCosm - 1
                xj = GrCosmInfo.xVer(j)
                yj = GrCosmInfo.yVer(j)
                If Abs(xi - xj) < Eps And Abs(yi - yj) < Eps Then
                    iCosmArcEnd(i) = j
                    Exit For
                End If
            Next j
        Next i
        
Dim xi1#, yi1#
Dim l#, sina#, cosa#
Dim xLoc#, yLoc#
Dim iPrevCosm As Long, iPrev As Long
Dim yLocMin#
    yLocMin = 10000000

' define number of segment of the  Arc cosmetic graphic
        For i = 0 To nVCosm - 2
            xi = GrCosmInfo.xVer(i)
            yi = GrCosmInfo.yVer(i)
            xi1 = GrCosmInfo.xVer(i + 1)
            yi1 = GrCosmInfo.yVer(i + 1)
            l = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
            sina = (yi1 - yi) / l
            cosa = (xi1 - xi) / l
            yLoc = (yPic - yi) * cosa - (xPic - xi) * sina
            xLoc = (yPic - yi) * sina + (xPic - xi) * cosa
            If xLoc > 0 And xLoc < l Then
                If Abs(yLoc) < yLocMin Then
                    iPrevCosm = i
                    yLocMin = Abs(yLoc)
                End If
            End If
        Next i
        
        iPrev = -1
        For i = 0 To ArcCount - 1
            If iPrevCosm > iCosmArcBeg(i) And iPrevCosm < iCosmArcEnd(i) Then
                iPrev = iBaseArcBeg(i)
            End If
        Next i
        
        If iPrev = -1 Then
            yLocMin = 10000000

' define number of segment of the  Arc cosmetic graphic
            For i = 0 To nVCon - 2
                xi = GrConInfo.xVer(i)
                yi = GrConInfo.yVer(i)
                xi1 = GrConInfo.xVer(i + 1)
                yi1 = GrConInfo.yVer(i + 1)
                l = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                If Abs(l) < Eps Then GoTo WWW
                sina = (yi1 - yi) / l
                cosa = (xi1 - xi) / l
                yLoc = (yPic - yi) * cosa - (xPic - xi) * sina
                xLoc = (yPic - yi) * sina + (xPic - xi) * cosa
                If xLoc > 0 And xLoc < l Then
                    If Abs(yLoc) < yLocMin Then
                        iPrev = i
                        yLocMin = Abs(yLoc)
                    End If
                End If
WWW:
           Next i
       End If
'MsgBox ("2222iPrev=" & CStr(iPrev))

        PreviousVertex = iPrev
End Function

