VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MyVB6Tool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' specify the number of tools provided by this add-in
Private Property Get NumTools() As Integer
  NumTools = 2
End Property
'specify whether the toolbar images are loaded from external bmp files or from program resources
Private Property Get LoadFromBitmap() As Boolean
  LoadFromBitmap = False 'in this case we are compiling in the images.
End Property
' TurboCAD requires this property in order to support the SDK's Tool.Description property
Public Property Get Description() As String
  Description = "My VB6 Tool"
End Property
' TurboCAD calls this function to initialize the tool when TurboCAD starts.
Public Function Initialize() As Boolean
  Initialize = True
End Function
'TurboCAD calls this function so it will know how to show the tool in the user interface.
Public Function GetToolInfo(CommandNames As Variant, MenuCaptions As Variant, _
                            StatusPrompts As Variant, ToolTips As Variant, _
                            Enabled As Variant, WantsUpdates As Variant) As Long

    'resize each of the arrays to match the number of tools
    ReDim CommandNames(NumTools)
    ReDim MenuCaptions(NumTools, 2)
    ReDim StatusPrompts(NumTools)
    ReDim ToolTips(NumTools)
    ReDim Enabled(NumTools)
    ReDim WantsUpdates(NumTools)
    
    'set up the information  for the first tool
    CommandNames(0) = "MyVBTool|Line" 'set the menu location for the first tool
    MenuCaptions(0, 0) = "&Single Line" ' set the menu caption, including alt-shortcut letter, for the first tool
    MenuCaptions(0, 1) = "M&yVBTool" 'Toolbar name
    StatusPrompts(0) = "Draw A Single Line" 'status bar prompt for the first tool
    ToolTips(0) = "Draws one line" 'mouse-over tooltip for the first tool
    Enabled(0) = True 'startup Enabled state for the first tool
    WantsUpdates(0) = False 'set to True if the tool's Enabled state may change
    
    'set up the information for the second tool in the same format
    CommandNames(1) = "MyVBTool|Rectangle"
    MenuCaptions(1, 0) = "&Rectangle"
    MenuCaptions(1, 1) = "M&yVBTool"
    StatusPrompts(1) = "Draw a rectangle"
    ToolTips(1) = "Draws a rectangle"
    Enabled(1) = True
    WantsUpdates(1) = False
    
    GetToolInfo = NumTools 'return the number of tools in the add-in
End Function

' TurboCAD calls this function to obtain the images for the buttons in the tool's toolbar.
' The GetButtonPicture function is a private function that determines which image to return to TurboCAD.
Public Function GetPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Object
    On Error GoTo PictureError
    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        Set GetPicture = TheImage
        Exit Function
    End If

PictureError:
    Set GetPicture = Nothing
End Function

Private Function GetButtonPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean, TheImage As StdPicture) As Boolean
    On Error GoTo LoadError

    'There are two ways to load images:  from .Bmp file(s) or from .RES resource.
    'In this demo, we control the loading by a private variable.
    
    'Note that if you are loading from .Bmp, or if you are running this tool as a
    '.VBP for debugging, you must place the .Res or .Bmp files in the Draggers subdirectory
    'of the directory in which IMSIGX16.DLL is located.

    If boolLoadFromBmp Then
        'Load from .Bmp file
        Dim strFileName As String 'File name of .Bmp file to load

        If LargeImage Then
            strFileName = App.Path & "\ToolLarge.bmp"
        Else
            strFileName = App.Path & "\ToolSmall.bmp"
        End If
        Set TheImage = LoadPicture(strFileName)
    Else
        'Load from .Res file
        Dim idBitmap%  'BITMAP resource id in .Res file

        If LargeImage Then
            idBitmap% = 101
        Else
            idBitmap% = 102
        End If
        Set TheImage = LoadResPicture(idBitmap%, vbResBitmap)
    End If

    'Return the image
    GetButtonPicture = True
    Exit Function

LoadError:
'        MsgBox "Error loading bitmap: " & Err.Description
        MsgBox LoadResString(113) & Err.Description
    GetButtonPicture = False
End Function

Public Function Run(ByVal Tool As Object) As Boolean
  Dim TCApp As IMSIGX.Application
  Set TCApp = Tool.Application
  Select Case Tool.Index
    Case 0: 'if the first tool is run
      TCApp.ActiveDrawing.Graphics.AddLineSingle 2, 2, 0, 12, 12, 0
      TCApp.ActiveDrawing.ActiveView.ZoomToExtents
    Case 1: 'if the second tool is run
      TCApp.ActiveDrawing.Graphics.AddLineRectangle 3, 3, 0, 11, 11, 0
      TCApp.ActiveDrawing.ActiveView.ZoomToExtents
  End Select
  Set TCApp = Nothing
  Run = True
  Exit Function

ErrH:
  MsgBox "Error " & Hex(Err.Number) & ": " & Err.Description
  Set TCApp = Nothing
End Function

