VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBTool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Const NUM_TOOLS = 1
'Toggle this to test loading buttons from .Bmp/.Res
Const boolLoadFromBmp As Boolean = False

Public Property Get Description() As String
    Description = "TurboCAD's VB tool"
End Property
'Fill arrays with information about tools in the package
'Return the number of tools in the package
'Return a description string for this package of tools

Public Function GetToolInfo(CommandNames As Variant, MenuCaptions As Variant, StatusPrompts As Variant, _
    ToolTips As Variant, Enabled As Variant, WantsUpdates As Variant) As Long
    'ReDim CommandNames(NUM_TOOLS, 5)
    ReDim CommandNames(NUM_TOOLS) ', 5)
    ReDim MenuCaptions(NUM_TOOLS, 2)
    ReDim StatusPrompts(NUM_TOOLS)
    ReDim ToolTips(NUM_TOOLS)
    ReDim Enabled(NUM_TOOLS)
    ReDim WantsUpdates(NUM_TOOLS)
' full command name include menu , submenu where tool will be placed
    CommandNames(0) = "S&DK|&Draggers|VB Tool"
' in our case you can find this tool in SDK\Draggers submenu
    MenuCaptions(0, 0) = "VB Tool"
    MenuCaptions(0, 1) = "Draggers"
    
    StatusPrompts(0) = "Run the TurboCAD's Visual Basic tool"
    ToolTips(0) = "TurboCAD's tool created with VisualBasic v6"
    Enabled(0) = True
    WantsUpdates(0) = False
    GetToolInfo = NUM_TOOLS
End Function

'Copy a windows bitmap of the requested size to the clipboard
'Bitmaps returned should contain NUM_TOOLS images
'Size of entire bitmap:
'Normal:  (NUM_TOOLS*16) wide x 15 high
'Large:   (NUM_TOOLS*24) wide x 23 high
'Mono bitmap should be 1-bit (black or white)
Public Function CopyBitmap(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Boolean
    On Error GoTo BitmapError

    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        'Put the image on the Windows clipboard
        Clipboard.SetData TheImage, vbCFDIB
        CopyBitmap = True
        Exit Function
    End If

BitmapError:
    CopyBitmap = False
End Function

Public Function GetPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Object
    On Error GoTo PictureError
    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        Set GetPicture = TheImage
        Exit Function
    End If

PictureError:
    Set GetPicture = Nothing
End Function

'Returns true if tool is correctly initialized
Public Function Initialize(ByVal Tool As Object) As Boolean
    Initialize = True
End Function

Private Function GetButtonPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean, TheImage As StdPicture) As Boolean
    On Error GoTo LoadError

    'There are two ways to load images:  from .Bmp file(s) or from .RES resource.
    'In this demo, we control the loading by a private variable.
    
    'Note that if you are loading from .Bmp, or if you are running this tool as a
    '.VBP for debugging, you must place the .Res or .Bmp files in the Draggers subdirectory
    'of the directory in which TCW40.EXE (or IMSIGX40.DLL) is located.

    If boolLoadFromBmp Then
        'Load from .Bmp file
        Dim strFileName As String 'File name of .Bmp file to load

        If LargeImage Then
            strFileName = App.Path & "\bmp2.bmp"
        Else
            strFileName = App.Path & "\bmp1.bmp"
        End If
        Set TheImage = LoadPicture(strFileName)
    Else
        'Load from .Res file
        Dim idBitmap%  'BITMAP resource id in .Res file

        If LargeImage Then
            idBitmap% = 102
        Else
            idBitmap% = 101
        End If
        Set TheImage = LoadResPicture(idBitmap%, vbResBitmap)
    End If

    'Return the image
    GetButtonPicture = True
    Exit Function

LoadError:
'        MsgBox "Error loading bitmap: " & Err.Description
        MsgBox LoadResString(113) & Err.Description
    GetButtonPicture = False
End Function
' put different validation in this function to determine if there is a condition
' to make this tool available
Public Function UpdateToolStatus(ByVal Tool As Object, Enabled As Boolean, Checked As Boolean) As Boolean
    Enabled = True 'Could do a test here to determine whether to disable the button/menu item
  
    UpdateToolStatus = True
End Function

Public Function Run(ByVal Tool As Object) As Boolean
    On Error GoTo ErrH
    Dim ActDr As Drawing
    Set ActDr = Tool.Application.ActiveDrawing
  
    
    MsgBox ActDr.Path
    ' add your code here
    
    
    
    Set ActDr = Nothing
    Run = True
    Exit Function
    
ErrH:
    MsgBox "Run method " & Err.Description
    Set ActDr = Nothing


End Function

